Type QFileView Extends QListView
  PRIVATE:
    lvPause             As Byte
    Initialized         As Byte
    SortColIndex        As Byte
    ColumnImageState(4) As Byte
    hSysImgLstSmall     As Long
    hSysImgLstNormal    As Long
    hListViewHeader     As Long
    hidFormat           As Long
    ColumnText(4)       As String
    HeaderImageList     As QImageList
    FileList            As QFileListBox

  PUBLIC:
    SelectedFiles As QStringList
    SafeMode      As Byte
    FileMask      As String

    Directory As String Property Set GetFilesFrom

  PRIVATE:
    Function GetFileDetails(file As String) As String
        Dim hFile    As Long
        Dim lSizeLow As Long
        Dim lpFSHigh As Long
        Dim FileDate As String
        Dim FileTime As String
        Dim FileSize As String

        hFile    = 0
        lSizeLow = 0
        lpFSHigh = 0
        FileDate = ""
        FileTime = ""
        FileSize = ""

        hFile = _lOpen(file, 0)

        If hFile > 0 Then
          GetFileTime(hFile, cFILETIME, aFILETIME, mFILETIME)
          FileTimeToLocalFileTime(mFILETIME, mFILETIME)
          FileTimeToSystemTime(mFILETIME, SYSTEMTIME)
          lSizeLow = GetFileSize(hFile, VarPtr(lpFSHigh))
          FileDate = Format$("%.2d", SYSTEMTIME.wMonth) & "/" & Format$("%.2d", SYSTEMTIME.wDay) & "/" & STR$(SYSTEMTIME.wYear)
          FileTime = Format$("%.2d", IIF(SYSTEMTIME.wHour > 12, SYSTEMTIME.wHour - 12, IIf(SYSTEMTIME.wHour = 0, SYSTEMTIME.wHour + 12, SYSTEMTIME.wHour))) & Format$(":%.2d", SYSTEMTIME.wMinute) & IIF(SYSTEMTIME.wHour > 11, " PM", " AM")
          FileSize = IIF((lSizeLow > 1024), Format$("%8s", Str$((lSizeLow\1024)+1)) & " KB", Format$("%11s", "1 KB"))
        End If

        _lClose(hFile)

        Result = FileDate & "," & FileTime & "," & FileSize

        hFile    = 0
        lSizeLow = 0
        lpFSHigh = 0
        FileDate = ""
        FileTime = ""
        FileSize = ""
    End Function

    Function GetItem(ByVal item As Long, ByVal subitem As Long) As String
        Dim GetStr As String

        GetStr = Space$(255) & Chr$(0)

        LVITEM.mask = LVIF_TEXT : LVITEM.iItem = item : LVITEM.iSubItem = subitem : LVITEM.pszText = VarPtr(GetStr) : LVITEM.cchTextMax = 256
        SendMessage(This.Handle, LVM_GETITEMA, 0, LVITEM)

        Result = VarPtr$(LVITEM.pszText)

        GetStr = ""
    End Function

    Sub SetItem(ByVal item As Long, ByVal subitem As Long, ByVal text As String)
        Dim SetStr As String

        SetStr = text & Chr$(0)

        LVITEM.mask = LVIF_TEXT : LVITEM.iItem = item : LVITEM.iSubItem = subitem : LVITEM.pszText = VarPtr(SetStr)
        SendMessage(This.Handle, LVM_SETITEMA, 0, LVITEM)

        SetStr = ""
    End Sub

    Sub SortItems(ByVal column As Long, ByVal state As Byte)
        Dim I            As Long
        Dim N            As Long
        Dim X            As Long
        Dim hFile        As Long
        Dim FileSize     As Long
        Dim FileName     As String
        Dim ItemText(4)  As String
        Dim SorterList   As QStringList
        Dim ParserList   As QStringList

        I            = 0
        N            = 0
        X            = 0
        hFile        = 0
        FileSize     = 0
        FileName     = ""
        ItemText(0)  = ""
        ItemText(1)  = ""
        ItemText(2)  = ""
        ItemText(3)  = ""
        ItemText(4)  = ""
        SorterList.Clear
        ParserList.Clear

        For I = 0 To (This.ItemCount-1)
          ItemText(0) = This.GetItem(I, 0) 'Name
          FileName    = Dir$(This.Directory & ItemText(0), &H827)
          ItemText(1) = Format$("%.15d", FileRec.FileTime) 'Serial Number form of Last Modified
          ItemText(2) = This.GetItem(I, 2) 'Type
          ItemText(3) = Format$("%11s", Str$(FileRec.Size)) 'Size
          ItemText(4) = This.GetItem(I, 1) 'Last Modified
          ItemText(5) = IIF(This.Item(I).Selected = True, "+", "-")
          Select Case column
            Case 0 '0,4,2,3
              SorterList.AddItems(ItemText(0) & "," & ItemText(1) & "," & ItemText(2) & "," & ItemText(3) & "," & ItemText(4) & "," & ItemText(5))
            Case 1 '1,4,2,3
              SorterList.AddItems(ItemText(1) & "," & ItemText(0) & "," & ItemText(2) & "," & ItemText(3) & "," & ItemText(4) & "," & ItemText(5))
            Case 2 '1,4,0,3
              SorterList.AddItems(ItemText(2) & "," & ItemText(0) & "," & ItemText(1) & "," & ItemText(3) & "," & ItemText(4) & "," & ItemText(5))
            Case 3 '1,4,3,0
              SorterList.AddItems(ItemText(3) & "," & ItemText(0) & "," & ItemText(1) & "," & ItemText(2) & "," & ItemText(4) & "," & ItemText(5))
            End Select
        Next I

        SorterList.Sort
        X = (SorterList.ItemCount - 1) 

        For I = 0 To X
          N = IIf((state = 0), I, (X - I))
          ParserList.Parse(SorterList.Item(N), ",")
          Select Case column
            Case 0
              This.SetItem(I, 0, ParserList.Item(0))
              This.SetItem(I, 1, ParserList.Item(4))
              This.SetItem(I, 2, ParserList.Item(2))
              FileSize = Val(ParserList.Item(3))
              ParserList.Item(3) = IIF((FileSize > 1024), Format$("%8s", Str$((FileSize\1024)+1)) & " KB", Format$("%11s", "1 KB"))
              This.SetItem(I, 3, ParserList.Item(3))
            Case 1
              This.SetItem(I, 0, ParserList.Item(1))
              This.SetItem(I, 1, ParserList.Item(4))
              This.SetItem(I, 2, ParserList.Item(2))
              FileSize = Val(ParserList.Item(3))
              ParserList.Item(3) = IIF((FileSize > 1024), Format$("%8s", Str$((FileSize\1024)+1)) & " KB", Format$("%11s", "1 KB"))
              This.SetItem(I, 3, ParserList.Item(3))
            Case 2
              This.SetItem(I, 0, ParserList.Item(1))
              This.SetItem(I, 1, ParserList.Item(4))
              This.SetItem(I, 2, ParserList.Item(0))
              FileSize = Val(ParserList.Item(3))
              ParserList.Item(3) = IIF((FileSize > 1024), Format$("%8s", Str$((FileSize\1024)+1)) & " KB", Format$("%11s", "1 KB"))
              This.SetItem(I, 3, ParserList.Item(3))
            Case 3
              This.SetItem(I, 0, ParserList.Item(1))
              This.SetItem(I, 1, ParserList.Item(4))
              This.SetItem(I, 2, ParserList.Item(3))
              FileSize = Val(ParserList.Item(0))
              ParserList.Item(0) = IIF((FileSize > 1024), Format$("%8s", Str$((FileSize\1024)+1)) & " KB", Format$("%11s", "1 KB"))
              This.SetItem(I, 3, ParserList.Item(0))
          End Select
          If ParserList.Item(5) = "+" Then
            This.Item(I).Selected = True
          Else
            This.Item(I).Selected = False
          End If
          SHGetFileInfo(This.Directory & This.GetItem(I, 0), 0, fvSFI, SizeOf(fvSFI), SHGFI_ICON)
          This.Item(I).ImageIndex = fvSFI.iIcon
          DestroyIcon(fvSFI.hIcon)
          ParserList.Clear
        Next I

        I            = 0
        N            = 0
        X            = 0
        hFile        = 0
        FileSize     = 0
        FileName     = ""
        ItemText(0)  = ""
        ItemText(1)  = ""
        ItemText(2)  = ""
        ItemText(3)  = ""
        ItemText(4)  = ""
        SorterList.Clear
        ParserList.Clear
    End Sub

    Sub Populate(ByVal path As String, ByVal mask As String)
        Dim I              As Long
        Dim File           As String
        Dim FileInfo       As String
        Dim FileDate       As String
        Dim FileTime       As String
        Dim FileSize       As String

        I        = 0
        File     = ""
        FileInfo = ""
        FileDate = ""
        FileTime = ""
        FileSize = ""

        Select Case This.SafeMode
          Case True
            This.FileList.DelFileTypes(ftReadOnly, ftHidden, ftSystem, ftDirectory)
            This.FileList.AddFileTypes(ftNormal)
          Case False
            This.FileList.DelFileTypes(ftDirectory)
            This.FileList.AddFileTypes(ftReadOnly, ftHidden, ftSystem, ftNormal)
        End Select

        This.FileList.Mask      = mask
        This.FileList.Directory = path

        If This.FileList.ItemCount > 0 Then
          For I = 0 To (This.FileList.ItemCount-1)
            File     = This.FileList.Item(I)
            FileInfo = This.GetFileDetails(This.Directory & File)
            FileDate = Field$(FileInfo, ",", 1)
            FileTime = Field$(FileInfo, ",", 2)
            FileSize = Field$(FileInfo, ",", 3)
            This.AddItems(File)
            This.Item(This.ItemCount-1).ImageIndex = -1
            This.AddSubItem((This.ItemCount-1), FileDate & Space$(2) & FileTime)
            SHGetFileInfo(This.Directory & File, 0, fvSFI, SizeOf(fvSFI), SHGFI_TYPENAME Or SHGFI_ICON)
            This.AddSubItem((This.ItemCount-1), fvSFI.szTypeName)
            This.AddSubItem((This.ItemCount-1), FileSize)
            This.Item(This.ItemCount-1).ImageIndex = fvSFI.iIcon
            DestroyIcon(fvSFI.hIcon)
          Next I
        End If

        I        = 0
        File     = ""
        FileInfo = ""
        FileDate = ""
        FileTime = ""
        FileSize = ""
    End Sub

    Sub ListView_OnClick
        Dim I As Long

        I = 0

        This.SelectedFiles.Clear

        For I = 0 To (This.ItemCount-1)
          If This.Item(I).Selected = True Then
            This.SelectedFiles.AddItems(This.Directory & This.GetItem(I, 0))
          End If
        Next I

        Browser_FileView_PM_Update(This.SelectedFiles)

        I = 0
    End Sub

    Sub ListView_OnChange
        If This.lvPause = False Then This.ListView_OnClick
    End Sub

    Sub ListView_OnColumnClick(ByVal column As Long)
        Dim State As Byte

        State = 0

        This.Cursor = crHourGlass

        If This.lvPause = False Then
          This.lvPause = True
          If This.ItemCount > 0 Then
            If column = This.SortColIndex Then
              State = This.ColumnImageState(column) Xor 1
              This.ColumnImageState(column) = State
              Select Case State
                Case 0
                  SendMessage(This.hListViewHeader, HDM_GETITEMA, column, HDI)
                  This.hidFormat = HDI.fmt Or HDF_IMAGE Or HDF_BITMAP_ON_RIGHT
                  HDI.fmt = This.hidFormat : HDI.iImage = 0 : HDI.pszText = VarPtr(This.ColumnText(column))
                  SendMessage(This.hListViewHeader, HDM_SETITEMA, column, HDI)
                Case 1
                  SendMessage(This.hListViewHeader, HDM_GETITEMA, column, HDI)
                  This.hidFormat = HDI.fmt Or HDF_IMAGE Or HDF_BITMAP_ON_RIGHT
                  HDI.fmt = This.hidFormat : HDI.iImage = 1 : HDI.pszText = VarPtr(This.ColumnText(column))
                  SendMessage(This.hListViewHeader, HDM_SETITEMA, column, HDI)
              End Select
            Else
              SendMessage(This.hListViewHeader, HDM_GETITEMA, This.SortColIndex, HDI)
              HDI.fmt = HDF_STRING : HDI.iImage = -1 : HDI.pszText = VarPtr(This.ColumnText(This.SortColIndex))
              SendMessage(This.hListViewHeader, HDM_SETITEMA, This.SortColIndex, HDI)
              State = This.ColumnImageState(column)
              Select Case State
                Case 0
                  SendMessage(This.hListViewHeader, HDM_GETITEMA, column, HDI)
                  This.hidFormat = HDI.fmt Or HDF_IMAGE Or HDF_BITMAP_ON_RIGHT
                  HDI.fmt = This.hidFormat : HDI.iImage = 0 : HDI.pszText = VarPtr(This.ColumnText(column))
                  SendMessage(This.hListViewHeader, HDM_SETITEMA, column, HDI)
                Case 1
                  SendMessage(This.hListViewHeader, HDM_GETITEMA, column, HDI)
                  This.hidFormat = HDI.fmt Or HDF_IMAGE Or HDF_BITMAP_ON_RIGHT
                  HDI.fmt = This.hidFormat : HDI.iImage = 1 : HDI.pszText = VarPtr(This.ColumnText(column))
                  SendMessage(This.hListViewHeader, HDM_SETITEMA, column, HDI)
              End Select
              This.SortColIndex = column
            End If
            This.SortItems(column, State)
            This.ListView_OnClick
          End If
          This.lvPause = False
        End If

        This.Cursor = crDefault

        State = 0
    End Sub

  PUBLIC:
    Property Set GetFilesFrom(path As String)
      Dim I As Long

      I = 0

      If DirExists(path) Then
        This.Cursor = crHourGlass
        This.Directory = IIf(Right$(path,1) = "\", path, path & "\")
        This.Clear
        This.Populate(This.Directory, This.FileMask)

        For I = 0 To 3
          SendMessage(This.hListViewHeader, HDM_GETITEMA, I, HDI)
          HDI.fmt = HDF_STRING : HDI.iImage = -1 : HDI.pszText = VarPtr(This.ColumnText(I))
          SendMessage(This.hListViewHeader, HDM_SETITEMA, I, HDI)
          This.ColumnImageState(I) = 0
        Next I

        SendMessage(This.hListViewHeader, HDM_GETITEMA, 0, HDI)

        This.hidFormat = HDI.fmt Or HDF_IMAGE Or HDF_BITMAP_ON_RIGHT
        HDI.fmt = This.hidFormat : HDI.iImage = 0 : HDI.pszText = VarPtr(This.ColumnText(0))
        SendMessage(This.hListViewHeader, HDM_SETITEMA, 0, HDI)

        This.SortColIndex = 0

        This.Cursor = crDefault

        I = 0
      End If
    End Property

    Function GetSelItems() As String
        Dim I As Long

        I = 0

        Result = This.SelectedFiles.Text

        For I = (This.ItemCount-1) To 0 Step -1
          If This.Item(I).Selected = True Then This.Item(I).Selected = False
        Next I

        I = 0
    End Function

    Sub Initialize(ByRef form As QForm)
      Dim ColumnText As String

      ColumnText = ""

      If This.Initialized = False Then
        This.FileList.Parent = form
        This.HeaderImageList.AddBMPhandle(UPARROW, RGB(255,000,255))
        This.HeaderImageList.AddBMPhandle(DOWNARROW, RGB(255,000,255))
        This.hSysImgLstSmall = SHGetFileInfo("c:\", 0, fvSFI, SizeOf(fvSFI), SHGFI_SMALLICON Or SHGFI_SYSICONINDEX)
        SendMessage(This.Handle, LVM_SETIMAGELIST, LVSIL_SMALL, This.hSysImgLstSmall)
        This.hSysImgLstNormal = SHGetFileInfo("c:\", 0, fvSFI, SizeOf(fvSFI), SHGFI_ICON Or SHGFI_SYSICONINDEX)
        SendMessage(This.Handle, LVM_SETIMAGELIST, LVSIL_NORMAL, This.hSysImgLstNormal)
        This.AddColumns(" ", " ", " ", " ")
        This.Column(0).Width = 205
        This.Column(1).Width = 176
        This.Column(2).Width = 160
        This.Column(3).Width = 104
        This.Column(0).Caption = This.ColumnText(0)
        This.Column(1).Caption = This.ColumnText(1)
        This.Column(2).Caption = This.ColumnText(2)
        This.Column(3).Caption = This.ColumnText(3)
        This.hListViewHeader = SendMessageAPI(This.Handle, LVM_GETHEADER, 0, 0)
        SendMessage(This.hListViewHeader, HDM_SETIMAGELIST, HDSIL_NORMAL, This.HeaderImageList.Handle)
        SendMessage(This.hListViewHeader, HDM_GETITEMA, 0, HDI)
        This.hidFormat = HDI.fmt Or HDF_IMAGE Or HDF_BITMAP_ON_RIGHT
        HDI.fmt = This.hidFormat : HDI.iImage = 0 : HDI.pszText = VarPtr(This.ColumnText(0))
        SendMessage(This.hListViewHeader, HDM_SETITEMA, 0, HDI)
        This.RowSelect = True
        SendMessage(This.Handle, LVM_SETEXTENDEDLISTVIEWSTYLE, LVS_EX_LABELTIP, -1)
        This.Initialized = True
      End If

      This.lvPause = False

      ColumnText = ""
    End Sub

    Constructor
      lvPause                = True
      Initialized            = False
      ColumnImageState(0)    = 0
      ColumnImageState(1)    = 0
      ColumnImageState(2)    = 0
      ColumnImageState(3)    = 0
      hSysImgLstSmall        = 0
      hSysImgLstNormal       = 0
      hListViewHeader        = 0
      hidFormat              = 0
      ColumnText(0)          = "Name"
      ColumnText(1)          = "Last Modified"
      ColumnText(2)          = "Type"
      ColumnText(3)          = "Size"
      HeaderImageList.Width  = 10
      HeaderImageList.Height = 10
      SortColIndex           = 0
      FileList.Visible       = False
      ViewStyle              = vsReport
      MultiSelect            = True
      ReadOnly               = True
      OnColumnClick          = This.ListView_OnColumnClick
      OnClick                = This.ListView_OnClick
      OnChange               = This.ListView_OnChange
      BorderStyle            = bsNone
      Left                   = 0
      Top                    = 0
      Width                  = 320
      Height                 = 240
      Font.Name              = "Courier New"
      Font.Size              = 10

      SafeMode               = True
      FileMask               = "*.*"
      Directory              = Command$(0) - Application.ExeName
    End Constructor
End Type
