'RapidQ RichEdit Custom Component (multiple custom components can be created).

Const RichEditStyleEx = WS_EX_ACCEPTFILES Or WS_EX_CLIENTEDGE Or WS_EX_WINDOWEDGE
Const RichEditStyle   = WS_VISIBLE Or WS_CHILD Or WS_VSCROLL Or WS_HSCROLL Or ES_MULTILINE Or ES_NOHIDESEL Or WS_TABSTOP Or WS_CLIPSIBLINGS

Declare Function EA_StartUp  Lib "EditAide.dll" Alias "EA_StartUp@8"  (ByVal REhWnd As Long, ByVal KeyWrdFile As String) As Long
Declare Sub      EA_DoThis   Lib "EditAide.dll" Alias "EA_DoThis@12"  (ByVal REhWnd As Long, ByVal FNThWnd As Long, ByVal ShowLNHL As Long)
Declare Sub      EA_ShutDown Lib "EditAide.dll" Alias "EA_ShutDown@0" ()

$Include <..\editaideSourceCode\EditAideEditor.inc>

Type API_RICHEDIT20A<size> Extends QObject
  PRIVATE:
    Initialize     As Long
    hReLibInst     As Long
    esTxtPos       As Long
    esTxtLen       As Long
    esCallBack     As Long
    ESCBptr        As Long
    FntRetPnt      As Long
    DoRetPnt       As Long
    SelRetPnt      As Long
    MicroSoft_Flaw As Long
    AddStrIdx      As Long
    strBufferLen   As Long
    TextLength     As Long
    LoopIndex      As Long
    LineCurPos     As Long
    LineStrPos     As Long
    LineCount      As Long
    FindFlags      As Long
    LastFind       As Long
    Identifier     As Long
    lpClipData     As Long
    lRetGetLine    As Long
    lRetFind       As Long
    lRetSetLine    As Long
    lModified      As Long

    sNull     As String
    sCrLf     As String
    esText    As String
    strBuffer As String
    clpBuffer As String
    cpyBuffer As String

    txtBuffer  As QStringList
    gotoList   As QStringList
    ParentRect As QRect

    Left(size)           As Long
    Top(size)            As Long
    Width(size)          As Long
    Height(size)         As Long
    Parent(size)         As Long
    Color(size)          As Long
    Visible(size)        As Long
    WordWrap(size)       As Long
    Modified(size)       As Long
    SelStart(size)       As Long
    SelLength(size)      As Long

    SelText(size)        As String
    Text(size)           As String

  PUBLIC:
    Handle(size)         As Long
    WndProc(size)        As Long

    Font.Name(size)      As String
    Font.Size(size)      As Long
    Font.Color(size)     As Long
    Font.Bold(size)      As Long
    Font.Italic(size)    As Long
    Font.Strikeout(size) As Long
    Font.Underline(size) As Long
    Font.CharSet(size)   As Long

  PRIVATE:
    With This
      Function ClearArrays(ByVal nSize As Long) As Long
        Dim lRet As Long
          For lRet = 0 To nSize
            .Handle(lRet)         = 0
            .WndProc(lRet)        = 0
            .Font.Name(lRet)      = ""
            .Font.Size(lRet)      = 0
            .Font.Color(lRet)     = 0
            .Font.Bold(lRet)      = 0
            .Font.Italic(lRet)    = 0
            .Font.Strikeout(lRet) = 0
            .Font.Underline(lRet) = 0
            .Font.CharSet(lRet)   = 0
            .Left(lRet)           = 0
            .Top(lRet)            = 0
            .Width(lRet)          = 0
            .Height(lRet)         = 0
            .Parent(lRet)         = 0
            .Color(lRet)          = 0
            .Visible(lRet)        = 0
            .WordWrap(lRet)       = 0
            .Modified(lRet)       = 0
            .SelStart(lRet)       = 0
            .SelLength(lRet)      = 0
            .SelText(lRet)        = ""
            .Text(lRet)           = ""
          Next lRet
        Result = lRet
      End Function

      Function EditStreamCallBack(ByVal dwCookie As Long, ByVal lpBuff As Long, ByVal cb As Long, ByVal pcb As Long) As Long
        Dim esBufferSize As Long
        Dim esBuffer     As String
        Dim esPosition   As Long
        Select Case dwCookie
          Case 1 'ES_STREAMIN
            esBufferSize = IIF(((.esTxtLen - .esTxtPos) + 1) < cb, (.esTxtLen - .esTxtPos), cb)
            esBuffer = Mid$(.esText, .esTxtPos, esBufferSize)
            MemCpy(lpBuff, VarPtr(esBuffer), esBufferSize)
            .esTxtPos = .esTxtPos + esBufferSize
            MemCpy(pcb, VarPtr(esBufferSize), 4)
          Case 2 'ES_STREAMOUT
            esBuffer = Mid$(VarPtr$(lpBuff), 1, cb)
            .esText = .esText & esBuffer
            esPosition = cb
            MemCpy(pcb, VarPtr(esPosition), 4)
        End Select
        esBufferSize = 0
        esBuffer = ""
        esPosition = 0
        Result = 0
      End Function
    End With

  PUBLIC:
    With This
      Function GetHandle(index As Byte) As Long
        Result = .Handle(index)
      End Function

      Sub SetParent(index As Byte, hParent As Long)
        If hParent <> 0 Then
          If .Parent(index) <> hParent Then
            .Parent(index) = hParent
            If .Handle(index) <> 0 Then SetParentAPI(.Handle(index), hParent)
            GetClientRect(hParent, This.ParentRect)
            .Left(index) = .ParentRect.Left : .Top(index) = .ParentRect.Top : .Width(index) = .ParentRect.Right : .Height(index) = .ParentRect.Bottom
          End If
        End If
      End Sub

      Function GetParent(index As Byte) As Long
        If .Handle(index) <> 0 Then
          Result = GetParentAPI(.Handle(index))
        End If
      End Function

      Sub SetModified(index As Byte, value As Long)
        If .Handle(index) <> 0 Then
          value = IIF(value = 0, 0, -1) 'API true = -1 (Not 1)
          SendMessage(.Handle(index), EM_SETMODIFY, value, 0)
        End If
      End Sub

      Function GetModified(index As Byte) As Long
        If .Handle(index) <> 0 Then
          .lModified = SendMessageAPI(.Handle(index), EM_GETMODIFY, 0, 0)
          Result = Abs(.lModified) 'API true = -1 (Not 1) so ABS() it.
        End If
      End Function

      Sub SetText(index As Byte, value As String)
        If .Text(index) <> value Then
          If .Handle(index) <> 0 Then
            .txtBuffer.Clear
            .txtBuffer.Text = value
            .strBuffer = ""
            .strBuffer = .txtBuffer.Text
            SendMessage(.Handle(index), WM_SETTEXT, 0, VarPtr(This.strBuffer))
            .Text(index) = .txtBuffer.Text
            .strBuffer = ""
            .txtBuffer.Clear
            .SetModified(index, False)
            SendMessage(.Handle(index), WM_PAINT, 0, 0)
            SetFocus(.Handle(index))
          End If
        End If
      End Sub

      Function GetText(index As Byte) As String
        If .Handle(index) <> 0 Then
          .txtBuffer.Clear
          .esText = ""
          EDITSTREAM.dwCookie = 2
          EDITSTREAM.dwError = 0
          EDITSTREAM.pfnCallback = .esCallBack
          SendMessage(.Handle(index), EM_STREAMOUT, SF_TEXT, EDITSTREAM)
          .txtBuffer.Text = .esText
          .Text(index) = .txtBuffer.Text
          .esText = ""
          .txtBuffer.Clear
          Result = .Text(index)
        End If
      End Function

      Sub SetColor(index As Byte, value As Long)
        If .Color(index) <> value Then .Color(index) = value
        If .Handle(index) <> 0 Then
          SendMessage(.Handle(index), EM_SETBKGNDCOLOR, 0, value)
          CC.CustColors(index) = value
          SetFocus(.Handle(index))
        End If
      End Sub

      Function GetColor(index As Byte) As Long
        If .Handle(index) <> 0 Then
          Result = .Color(index)
        End If
      End Function

      Sub SetSelText(index As Byte, value As String)
        If .Handle(index) <> 0 Then
          .strBuffer = ""
          .strBuffer = value
          SendMessage(.Handle(index), EM_REPLACESEL, 1, VarPtr(This.strBuffer))
          .strBuffer = ""
        End If
      End Sub

      Function GetSelText(index As Byte) As String
        If .Handle(index) <> 0 Then
          .strBuffer = ""
          .strBuffer = String$(Len(.Text(index)), Chr$(32))
          .strBufferLen = SendMessageAPI(.Handle(index), EM_GETSELTEXT, 0, VarPtr(This.strBuffer))
          If .strBufferLen = 0 Then
            Result = ""
          Else
            Result = Mid$(.strBuffer, 1, .strBufferLen)
          End If
          .strBuffer = ""
        End If
      End Function

      Sub SetSelStart(index As Byte, value As Long)
        If .Handle(index) <> 0 And value > -1 Then
          SetSELRANGE.cpMin = value
          SetSELRANGE.cpMax = value
          SendMessage(.Handle(index), EM_EXSETSEL, 0, SetSELRANGE)
          SetFocus(.Handle(index))
        End If
      End Sub

      Function GetSelStart(index As Byte) As Long
        If .Handle(index) <> 0 Then
          .LineCurPos = 0
          SendMessage(.Handle(index), EM_GETSEL, VarPtr(This.LineCurPos), 0)
          Result = .LineCurPos
        End If
      End Function

      Sub SetSelLength(index As Byte, value As Long)
        If .Handle(index) <> 0 And value Then
          SetSELRANGE.cpMin = .GetSelStart(index)
          SetSELRANGE.cpMax = SetSELRANGE.cpMin + value
          SendMessage(.Handle(index), EM_EXSETSEL, 0, SetSELRANGE)
          SetFocus(.Handle(index))
        End If
      End Sub

      Function GetSelLength(index As Byte) As Long
        If .Handle(index) <> 0 Then
          'EM_GETSELTEXT and EM_EXGETSEL ignores LineFeeds (aka Chr$(10))
          'MS was informed of this flaw Mid-April of 2009.
          SendMessage(.Handle(index), EM_EXGETSEL, 0, GetSELRANGE)
          .strBuffer = ""
          .strBuffer = String$(MaxFileSize, Chr$(32))
          .strBufferLen = SendMessageAPI(.Handle(index), EM_GETSELTEXT, 0, VarPtr(This.strBuffer))
          .txtBuffer.Text = .strBuffer
          .strBuffer = ""
          .MicroSoft_Flaw = .txtBuffer.ItemCount
          .txtBuffer.Clear
          Result = (GetSELRANGE.cpMax - GetSELRANGE.cpMin) + IIF(.MicroSoft_Flaw = 0, 0, .MicroSoft_Flaw - 1)
        End If
      End Function

      Sub SetVisible(index As Byte, value As Long)
        If .Handle(index) <> 0 Then
          value = IIF(value = 0, 0, 1)
          If .Visible(index) <> value Then .Visible(index) = value
          If value = True Then
            ShowWindow(.Handle(index), SW_SHOWNORMAL)
          Else
            ShowWindow(.Handle(index), SW_HIDE)
          End If
        End If
      End Sub

      Function GetVisible(index As Byte) As Long
        Result = .Visible(index)
      End Function

      Sub SetWordWrap(index As Byte, value As Long)
        value = IIF(value = 0, 0, 1)
        If .WordWrap(index) <> value Then .WordWrap(index) = value
        If .Handle(index) <> 0 Then
          Select Case value
            Case True
              SendMessage(.Handle(index), EM_SETTARGETDEVICE, 0, 0) 'Oddity: lParam needs to be the opposite of what you want.
              SetWindowPos(.Handle(index), 0, 0, 0, 0, 0, SWP_FRAMECHANGED Or SWP_NOMOVE Or SWP_NOSIZE)
            Case False
              SendMessage(.Handle(index), EM_SETTARGETDEVICE, 0, -1) 'Oddity: lParam needs to be the opposite of what you want.
              SetWindowPos(.Handle(index), 0, 0, 0, 0, 0, SWP_FRAMECHANGED Or SWP_NOMOVE Or SWP_NOSIZE)
          End Select
          SetFocus(.Handle(index))
        End If
      End Sub

      Function GetWordWrap(index As Byte) As Long
        Result = .WordWrap(index)
      End Function

      Sub SetLine(index As Byte, num As Long, value As String)
        If .Handle(index) <> 0 Then
          .lRetSetLine = SendMessageAPI(.Handle(index), EM_LINEINDEX, num, 0)
          If .lRetSetLine > -1 Then
            .esText = ""
            EDITSTREAM.dwCookie = 2
            EDITSTREAM.dwError = 0
            EDITSTREAM.pfnCallback = .esCallBack
            SendMessage(.Handle(index), EM_STREAMOUT, SF_TEXT, EDITSTREAM)
            .txtBuffer.Clear
            .txtBuffer.Text = .esText
            .txtBuffer.Item(num) = value
            .strBuffer = ""
            .strBuffer = .txtBuffer.Text & Chr$(0)
            SendMessage(.Handle(index), EM_SETTEXTEX, SETTEXTEX, VarPtr(This.strBuffer))
            .strBuffer = ""
            .txtBuffer.Clear
            .esText = ""
            EDITSTREAM.dwCookie = 2
            EDITSTREAM.dwError = 0
            EDITSTREAM.pfnCallback = .esCallBack
            SendMessage(.Handle(index), EM_STREAMOUT, SF_TEXT, EDITSTREAM)
            .txtBuffer.Text = .esText
            .Text(index) = .txtBuffer.Text
            .txtBuffer.Clear
            .esText = ""
            .SetModified(index, True)
            SendMessage(.Handle(index), WM_PAINT, 0, 0)
            .SetSelStart(index, SendMessageAPI(.Handle(index), EM_LINEINDEX, num, 0))
            SetFocus(.Handle(index))
          End If
        End If
      End Sub

      Function GetLine(index As Byte, value As Long) As String
        If .Handle(index) <> 0 Then
          .strBuffer = ""
          .strBuffer = "0BFE" & String$(3066, Chr$(32)) '0BFE = 3070 (the "total" buffer size). 0BFE will be over-written upon return.
          .lRetGetLine = SendMessageAPI(.Handle(index), EM_GETLINE, value, VarPtr(This.strBuffer))
          If .lRetGetLine = 0 Then
            .strBuffer = ""
            Result = ""
          Else
            Result = rTrim$(.strBuffer)
            .strBuffer = ""
          End If
        End If
      End Function

      Function WhereY(index As Byte) As Long
        If .Handle(index) <> 0 Then
          .LineCurPos = 0
          SendMessage(.Handle(index), EM_GETSEL, VarPtr(This.LineCurPos), 0)
          Result = SendMessageAPI(.Handle(index), EM_EXLINEFROMCHAR, 0, .LineCurPos)
        End If
      End Function

      Function WhereX(index As Byte) As Long
        If .Handle(index) <> 0 Then
          .LineStrPos = SendMessageAPI(.Handle(index), EM_LINEINDEX, -1, 0)
          .LineCurPos = 0
          SendMessage(.Handle(index), EM_GETSEL, VarPtr(This.LineCurPos), 0)
          Result = .LineCurPos - .LineStrPos
        End If
      End Function

      Function GetLineCount(index As Byte) As Long
        If .Handle(index) <> 0 And .WordWrap(index) = True Then 'workaround if WordWrap equals True
          .txtBuffer.Clear
          .esText = ""
          EDITSTREAM.dwCookie = 2
          EDITSTREAM.dwError = 0
          EDITSTREAM.pfnCallback = .esCallBack
          SendMessage(.Handle(index), EM_STREAMOUT, SF_TEXT, EDITSTREAM)
          .txtBuffer.Text = .esText
          Result = .txtBuffer.ItemCount + 1
          .txtBuffer.Clear
        ElseIf .Handle(index) <> 0 And .WordWrap(index) = False Then
          Result = SendMessageAPI(.Handle(index), EM_GETLINECOUNT, 0, 0)
        End If
      End Function

      Function GetTextLength(index As Byte) As Long
        If .Handle(index) <> 0 Then
          Result = SendMessageAPI(.Handle(index), WM_GETTEXTLENGTHEX, GTL, 0)
        End If
      End Function

      Sub JumpTo(index As Byte, value As String)
        Dim I         As Long
        Dim N         As Long
        Dim sLineText As String
        Dim sLineWord As String

        If .Handle(index) <> 0 Then
          .LineCount = .GetLineCount(index) - 1
          JumpToComboBox.Clear
          .gotoList.Clear
          Select Case value
            Case "Subroutines"
              JumpToLabel.Caption = "JumpTo Subroutine..."
              For I = 0 To .LineCount
                sLineText = lTrim$(.GetLine(index, I))
                If lCase$(Left$(sLineText, 4)) = "sub " Then
                  N = Instr(5, sLineText, "(")
                  If N = 0 Then N = Instr(5, sLineText, " ")
                  If N = 0 Then N = Instr(5, sLineText, Chr$(13))
                  sLineWord = Mid$(sLineText, 5, (N - 5))
                  .gotoList.AddItems(sLineWord & ":" & Str$(I))
                  JumpToComboBox.AddItems(sLineWord)
                End If
              Next I
            Case "Functions"
              JumpToLabel.Caption = "JumpTo Function..."
              For I = 0 To .LineCount
                sLineText = lTrim$(.GetLine(index, I))
                If lCase$(Left$(sLineText, 9)) = "function " Then
                  N = Instr(10, sLineText, "(")
                  If N = 0 Then N = Instr(10, sLineText, " ")
                  If N = 0 Then N = Instr(10, sLineText, Chr$(13))
                  sLineWord = Mid$(sLineText, 10, (N - 10))
                  .gotoList.AddItems(sLineWord & ":" & Str$(I))
                  JumpToComboBox.AddItems(sLineWord)
                End If
              Next I
          End Select

          If JumpToComboBox.ItemCount > 0 Then
            JumpToComboBox.ItemIndex = 0
            SetFocus(JumpToComboBox.Handle)

            If JumpToForm.ShowModal = mrOK Then
              .SetSelStart(index, Len(.Text(index)))
              I = Val(Field$(.gotoList.Item(JumpToComboBox.ItemIndex), ":", 2))
              .LineStrPos = SendMessageAPI(.Handle(index), EM_LINEINDEX, I, 0)
              .SetSelStart(index, .LineStrPos)
              SendMessage(.Handle(index), WM_PAINT, 0, 0)
            End If
          Else
            MessageDlg(Chr$(10) & "Could not find any " & value & ".", mtInformation, mbOk, 0)
          End If

          SetFocus(.Handle(index))
        End If
      End Sub

      Sub ClearUndoBuffer(index As Byte) 'Optional: Changing the Font adds an Undo entry (there's no way to avoid the entry).
        If .Handle(index) <> 0 Then
          SendMessage(.Handle(index), EM_EMPTYUNDOBUFFER, 0, 0)
        End If
      End Sub

      Sub Undo(index As Byte)
        If .Handle(index) <> 0 Then
          .DoRetPnt = .GetSelStart(index)
          SendMessage(.Handle(index), EM_UNDO, 0, 0)
          .SetSelStart(index, .DoRetPnt)
          SetFocus(.Handle(index))
        End If
      End Sub

      Sub Redo(index As Byte)
        If .Handle(index) <> 0 Then
          .DoRetPnt = .GetSelStart(index)
          SendMessage(.Handle(index), EM_REDO, 0, 0)
          .SetSelStart(index, .DoRetPnt)
          SetFocus(.Handle(index))
        End If
      End Sub

      Sub SelectAll(index As Byte)
        If .Handle(index) <> 0 Then
          .SelRetPnt = .GetSelStart(index)
          SendMessage(.Handle(index), EM_SETSEL, 0, -1)
        End If
      End Sub

      Sub UnSelectAll(index As Byte)
        If .Handle(index) <> 0 Then
          .TextLength = SendMessageAPI(.Handle(index), WM_GETTEXTLENGTH, 0, 0)
          SetSELRANGE.cpMin = IIF(.SelRetPnt <= .TextLength, .SelRetPnt, .TextLength)
          SetSELRANGE.cpMax = SetSELRANGE.cpMin
          SendMessage(.Handle(index), EM_EXSETSEL, 0, SetSELRANGE)
        End If
      End Sub

      Sub Cut(index As Byte)
        If .Handle(index) <> 0 Then
          SendMessage(.Handle(index), WM_CUT, 0, 0)
          SetFocus(.Handle(index))
        End If
      End Sub

      Sub Copy(index As Byte)
        If .Handle(index) <> 0 Then
          SendMessage(.Handle(index), WM_COPY, 0, 0)
          SetFocus(.Handle(index))
        End If
      End Sub

      Sub Paste(index As Byte)
        If .Handle(index) <> 0 Then
          .lpClipData = 0
          ClipBoard.Open
            .lpClipData = GetClipBoardData(CF_TEXT)
            If .lpClipData Then
              .clpBuffer = ""
              .clpBuffer = VarPtr$(.lpClipData)
              .cpyBuffer = ""
              .cpyBuffer = ReplaceSubStr$(.clpBuffer, Chr$(9), Space$(4))
              .SetSelText(index, .cpyBuffer)
              .clpBuffer = ""
              .cpyBuffer = ""
            End If
          ClipBoard.Close
          SetFocus(.Handle(index))
        End If
      End Sub

      Sub Delete(index As Byte)
        If .Handle(index) <> 0 Then
          SendMessage(.Handle(index), ENHANCED_KEY, VK_DELETE, 0)
          SetFocus(.Handle(index))
        End If
      End Sub

      Sub Clear(index As Byte)
        If .Handle(index) <> 0 Then
          .strBuffer = ""
          SendMessage(.Handle(index), WM_SETTEXT, 0, VarPtr(This.strBuffer))
          .Text(index) = .strBuffer
          .strBuffer = ""
          .SetModified(index, False)
          SetFocus(.Handle(index))
        End If
      End Sub

      Sub LoadFromFile(index As Byte, value As String)
        If .Handle(index) <> 0 Then
          NameOfFile(index) = value
          .Clear(index)
          .strBuffer = ""
          .txtBuffer.Clear
          .txtBuffer.LoadFromFile(value)
          .strBuffer = ReplaceSubStr$(.txtBuffer.Text, Chr$(9), Space$(4))
          SendMessage(.Handle(index), WM_SETTEXT, 0, VarPtr(This.strBuffer))
          .Text(index) = .txtBuffer.Text
          .strBuffer = ""
          .txtBuffer.Clear
          SetSELRANGE.cpMin = 0
          SetSELRANGE.cpMax = 0
          SendMessage(.Handle(index), EM_EXSETSEL, 0, SetSELRANGE)
          .SetModified(index, False)
          SetFocus(.Handle(index))
        End If
      End Sub

      Sub Save(index As Byte)
        If .Handle(index) <> 0 Then
          If NameOfFile(index) = "" Then
            MessageDlg("Error: No Filename!" & Chr$(10) & "Please use SaveAs...", mtError, mbOk, 0)
          Else
            .esText = ""
            EDITSTREAM.dwCookie = 2
            EDITSTREAM.dwError = 0
            EDITSTREAM.pfnCallback = .esCallBack
            SendMessage(.Handle(index), EM_STREAMOUT, SF_TEXT, EDITSTREAM)
            .txtBuffer.Clear
            .txtBuffer.Text = .esText
            .txtBuffer.SaveToFile(NameOfFile(index))
            .esText = ""
            .txtBuffer.Clear
            .SetModified(index, False)
            SetFocus(.Handle(index))
          End If
        End If
      End Sub

      Sub SaveToFile(index As Byte, value As String)
        If .Handle(index) <> 0 Then
          .esText = ""
          EDITSTREAM.dwCookie = 2
          EDITSTREAM.dwError = 0
          EDITSTREAM.pfnCallback = .esCallBack
          SendMessage(.Handle(index), EM_STREAMOUT, SF_TEXT, EDITSTREAM)
          .txtBuffer.Clear
          .txtBuffer.Text = .esText
          .txtBuffer.SaveToFile(value)
          .esText = ""
          .txtBuffer.Clear
          NameOfFile(index) = value
          .SetModified(index, False)
          SetFocus(.Handle(index))
        End If
      End Sub

      Sub LoadFromMemStream(index As Byte, Stream As QMemoryStream)
        .strBuffer = ""
        .strBuffer = Stream.ReadBinStr(Stream.Size)
        .SetText(index, .strBuffer)
        .strBuffer = ""
      End Sub

      Sub SaveToMemStream(index As Byte, Stream As QMemoryStream)
        .strBuffer = ""
        .strBuffer = .GetText(index)
        Stream.WriteBinStr(This.strBuffer, Len(This.strBuffer))
        .strBuffer = ""
      End Sub

      SubI AddStrings(...)
        .Identifier = ParamVal(1)
        If .Handle(.Identifier) <> 0 Then
          .esText = ""
          EDITSTREAM.dwCookie = 2
          EDITSTREAM.dwError = 0
          EDITSTREAM.pfnCallback = .esCallBack
          SendMessage(.Handle(.Identifier), EM_STREAMOUT, SF_TEXT, EDITSTREAM)
          .strBuffer = ""
          For This.AddStrIdx = 1 To ParamStrCount
            .strBuffer = .strBuffer & ParamStr$(This.AddStrIdx) & .sCrLf
          Next This.AddStrIdx
          .strBuffer = .esText & .strBuffer & Chr$(0)
          SendMessage(.Handle(.Identifier), EM_SETTEXTEX, SETTEXTEX, VarPtr(This.strBuffer))
          .strBuffer = ""
          .esText = ""
          EDITSTREAM.dwCookie = 2
          EDITSTREAM.dwError = 0
          EDITSTREAM.pfnCallback = .esCallBack
          SendMessage(.Handle(.Identifier), EM_STREAMOUT, SF_TEXT, EDITSTREAM)
          .txtBuffer.Clear
          .txtBuffer.Text = .esText
          .Text(.Identifier) = .txtBuffer.Text
          .esText = ""
          .txtBuffer.Clear
          SetSELRANGE.cpMin = SendMessageAPI(.Handle(.Identifier), WM_GETTEXTLENGTH, 0, 0)
          SetSELRANGE.cpMax = SetSELRANGE.cpMin
          SendMessage(.Handle(.Identifier), EM_EXSETSEL, 0, SetSELRANGE)
          .SetModified(.Identifier, True)
          SetFocus(.Handle(.Identifier))
        End If
      End SubI

      Sub SetFont.Name(index As Byte, value As String)
        If .Font.Name(index) <> value Then .Font.Name(index) = value
      End Sub

      Function GetFont.Name(index As Byte) As String
        Result = .Font.Name(index)
      End Function

      Sub SetFont.Size(index As Byte, value As Long)
        If .Font.Size(index) <> value Then .Font.Size(index) = value
      End Sub

      Function GetFont.Size(index As Byte) As Long
        Result = .Font.Size(index)
      End Function

      Sub SetFont.Color(index As Byte, value As Long)
        If .Font.Color(index) <> value Then .Font.Color(index) = value
      End Sub

      Function GetFont.Color(index As Byte) As Long
        Result = .Font.Color(index)
      End Function

      Sub SetFont.Bold(index As Byte, value As Long)
        If .Font.Bold(index) <> value Then .Font.Bold(index) = IIF(value = False, 0, CFE_BOLD)
      End Sub

      Function GetFont.Bold(index As Byte) As Long
        Result = .Font.Bold(index)
      End Function

      Sub SetFont.Italic(index As Byte, value As Long)
        If .Font.Italic(index) <> value Then .Font.Italic(index) = IIF(value = False, 0, CFE_ITALIC)
      End Sub

      Function GetFont.Italic(index As Byte) As Long
        Result = .Font.Italic(index)
      End Function

      Sub SetFont.Strikeout(index As Byte, value As Long)
        If .Font.Strikeout(index) <> value Then .Font.Strikeout(index) = IIF(value = False, 0, CFE_STRIKEOUT)
      End Sub

      Function GetFont.Strikeout(index As Byte) As Long
        Result = .Font.Strikeout(index)
      End Function

      Sub SetFont.Underline(index As Byte, value As Long)
        If .Font.Underline(index) <> value Then .Font.Underline(index) = IIF(value = False, 0, CFE_UNDERLINE)
      End Sub

      Function GetFont.Underline(index As Byte) As Long
        Result = .Font.Underline(index)
      End Function

      Sub SetFont.CharSet(index As Byte, value As Long)
        If .Font.CharSet(index) <> value Then .Font.CharSet(index) = value
      End Sub

      Function GetFont.CharSet(index As Byte) As Long
        Result = .Font.CharSet(index)
      End Function

      Sub SetFont(index As Byte, value As QFont)
        If .Handle(index) <> 0 Then .FntRetPnt = .GetSelStart(index)
        If .Font.Name(index)      <> value.Name      Then .Font.Name(index)      = value.Name
        If .Font.Size(index)      <> value.Size      Then .Font.Size(index)      = value.Size
        If .Font.Color(index)     <> value.Color     Then .Font.Color(index)     = value.Color
        If .Font.Bold(index)      <> value.Bold      Then .Font.Bold(index)      = value.Bold
        If .Font.Italic(index)    <> value.Italic    Then .Font.Italic(index)    = value.Italic
        If .Font.Strikeout(index) <> value.Strikeout Then .Font.Strikeout(index) = value.Strikeout
        If .Font.Underline(index) <> value.Underline Then .Font.Underline(index) = value.Underline
        If .Font.CharSet(index)   <> value.CharSet   Then .Font.CharSet(index)   = value.CharSet
        CHARFORMAT.szFaceName  = .Font.Name(index) & .sNull
        CHARFORMAT.yHeight     = .Font.Size(index) * 20 'Adjust the 20 to something more appropriate if your screen resolution is not 96dpi.
        CHARFORMAT.crTextColor = .Font.Color(index)
        CHARFORMAT.dwEffects   = .Font.Bold(index) Or .Font.Italic(index) Or .Font.Strikeout(index) Or .Font.Underline(index)
        CHARFORMAT.bCharSet    = .Font.CharSet(index)
        CHARFORMAT.dwMask      = CFM_BOLD Or CFM_ITALIC Or CFM_FACE Or CFM_COLOR Or CFM_SIZE Or CFM_STRIKEOUT Or CFM_UNDERLINE Or CFM_CHARSET
        CHARFORMAT.crBackColor = .Color(index)
        If .Handle(index) <> 0 Then
          SendMessage(.Handle(index), EM_SETCHARFORMAT, SCF_ALL, CHARFORMAT)
          .SetSelStart(index, .FntRetPnt)
          .SetModified(index, False)
          SetFocus(.Handle(index))
        End If
      End Sub

      Sub Resize(index As Byte) 'Hence the reason for having a QPanel as a Parent for the RichEdit.
        If .Parent(index) <> 0 Then GetClientRect(.Parent(index), This.ParentRect)
        If .Handle(index) <> 0 And .Parent(index) <> 0 Then
          .Left(index) = .ParentRect.Left : .Top(index) = .ParentRect.Top : .Width(index) = .ParentRect.Right : .Height(index) = .ParentRect.Bottom
          SetWindowPos(.Handle(index), 0, .Left(index), .Top(index), .Width(index), .Height(index), SWP_FRAMECHANGED)
          SetFocus(.Handle(index))
        End If
      End Sub

      Sub Repaint(index As Byte)
        If .Handle(index) <> 0 Then
          ShowWindow(.Handle(index), SW_HIDE)
          ShowWindow(.Handle(index), SW_SHOWNORMAL)
          SetFocus(.Handle(index))
        End If
      End Sub

      Sub ShutDown(index As Byte)
        If .Handle(index) <> 0 Then
          .Clear(index)
          DestroyWindow(.Handle(index))
        End If
      End Sub

      Sub Free
        If .hReLibInst Then FreeLibrary(.hReLibInst)
      End Sub

      Function CreateNew(index As Byte, hParent As Long) As Long
        If .Handle(index) = 0 Then
          If hParent <> 0 And .hReLibInst <> 0 Then
            .SetParent(index, hParent)
            .Handle(index) = CreateWindowEx(RichEditStyleEx, "RichEdit20A", "", RichEditStyle, .Left(index), .Top(index), .Width(index), .Height(index), hParent, 0, Application.hInstance, 0)
            SendMessage(.Handle(index), EM_SETTEXTMODE, TM_PLAINTEXT Or TM_MULTILEVELUNDO Or TM_SINGLECODEPAGE, 0)
            .WndProc(index) = GetWindowLong(.Handle(index), GWL_WNDPROC)
          End If
          Result = (.Handle(index) <> 0)
        End If
      End Function
    End With

    Constructor
      Initialize     = This.ClearArrays(size)
      MicroSoft_Flaw = 0
      AddStrIdx      = 0
      strBufferLen   = 0
      LineCurPos     = 0
      FntRetPnt      = 0
      DoRetPnt       = 0
      TextLength     = 0
      LoopIndex      = 0
      hReLibInst     = LoadLibrary("Riched20.dll")
      esTxtPos       = 0
      esTxtLen       = 0
      ESCBptr        = 0
      Bind This.ESCBptr To This.EditStreamCallBack
      esCallBack = SetNewCallBack_4(This.ESCBptr)
      LineStrPos     = 0
      LineCount      = 0
      FindFlags      = 0
      LastFind       = 0
      lpClipData     = 0
      Identifier     = 0
      lRetGetLine    = 0
      lRetFind       = 0
      lModified      = 0
      lRetSetLine    = 0
      sNull          = Chr$(0) & Chr$(0)
      sCrLf          = Chr$(13) & Chr$(10)
      esText         = ""
      strBuffer      = ""

      Width(0)          = 312
      Height(0)         = 167
      Color(0)          = RGB(255,255,255)
      Font.Name(0)      = "System"
      Font.Size(0)      = 10
      Font.Color(0)     = RGB(000,000,000)
      Font.Bold(0)      = False
      Font.Italic(0)    = False
      Font.Strikeout(0) = False
      Font.Underline(0) = False
      Font.CharSet(0)   = DEFAULT_CHARSET
      Visible(0)        = True
      WordWrap(0)       = False
      Modified(0)       = False
    End Constructor
End Type
