$Optimize ON
$Option EXPLICIT
$Include "RapidQ.inc"

Type EAE_TCHOOSECOLOR
    lStructSize As Long
    hWndOwner As Long
    hInstance As Long
    rgbResult As Long
    CustColors(1 To 16) As Long
    Flags As DWord
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As Long
End Type

Declare Function EAE_ChooseClrDlg Lib "comdlg32" Alias "ChooseColorA" (TCC As EAE_TCHOOSECOLOR) As Long
Declare Function EAE_SetFocus Lib "user32" Alias "SetFocus" (ByVal hWnd As Long) As Long
Declare Function EAE_ColorRGBToHLS Lib "shlwapi" Alias "ColorRGBToHLS" (ByVal clrRGB As Long, pwHue As Long, pwLuminance As Long, pwSaturation As Long) As Long
Declare Function EAE_RedrawWindow Lib "user32" Alias "RedrawWindow" (ByVal hWnd As Long, lpRgn As Long, lpRect As Long, bRedraw As Long) As Long

Declare Sub EAE_Edit(ByVal hWnd_RE As Long, ByVal sStr_KeyWrdFile As String)
Declare Sub EAE_SetUp
Declare Sub EAE_Save(ByVal sStr_KeyWrdFile As String)
Declare Sub EAE_SaveNewDefaultsExit
Declare Sub EAE_Exit

Declare Sub RestoreDefaults

Declare Sub KeyToExt
Declare Sub ExtToKey
Declare Sub MoveKeyToExt
Declare Sub MoveExtToKey
Declare Sub AddKeyWrd
Declare Sub AddExtWrd
Declare Sub DelWrd

Declare Sub KeyWrdAddChk
Declare Sub ExtWrdAddChk

Declare Sub ChgPanelClr(Sender As QPanel)

Declare Sub EAE_MenuChk

Declare Sub Grab_RGB_HLS(Sender As QPanel)

DefStr EAE_LF = Chr$(10)
DefStr EAE_KeyWrdFile
DefStr EAE_InstallPath

DefLng EAE_hWndRE
DefLng HL_lRetCC

DefLng HL_Red, HL_Green, HL_Blue
DefLng HL_Idx, HL_N
DefLng LoadedFromFile
DefLng PanelColor

DefLng KeyWrdClrOrg
DefLng ExtWrdClrOrg
DefLng RemarkClrOrg
DefLng QuotesClrOrg
DefLng LN_BG_ClrOrg
DefLng LN_FG_ClrOrg

DefLng KeyWrdClrDef
DefLng ExtWrdClrDef
DefLng RemarkClrDef
DefLng QuotesClrDef
DefLng LN_BG_ClrDef
DefLng LN_FG_ClrDef

DefLng EAE_Chk
DefLng EAE_Ret

DefLng EAE_lHue
DefLng EAE_lLum
DefLng EAE_lSat

Dim TCC As EAE_TCHOOSECOLOR
    TCC.lStructSize   = SizeOf(TCC)

Dim LoadFileList As QStringList
Dim ModifiedList As QStringList

Dim ColorListDef As QStringList
Dim KeyWrdLstDef As QStringList
Dim ExtWrdLstDef As QStringList

Dim CommentsOrg As QStringList
    CommentsOrg.AddItems("'''  Author: David Burkley")
    CommentsOrg.AddItems("'''   Email: burkleyd@yahoo.com")
    CommentsOrg.AddItems("'''    Date: January 18th, 2010")
    CommentsOrg.AddItems("'''")
    CommentsOrg.AddItems("' Warning: Do NOT edit this file manually.")
    CommentsOrg.AddItems("' If you do... text highlighting, in EditAide, will not work.")
    CommentsOrg.AddItems("' If you do need to edit it... start EditAide and select the EditAide Defaults option.")
    CommentsOrg.AddItems("' Then click the Set HighLight and Line Number Defaults button.")

Dim ColorListOrg As QStringList
    ColorListOrg.AddItems("KeyWrdColor=RGB(000,000,150)")
    ColorListOrg.AddItems("ExtWrdColor=RGB(144,000,144)")
    ColorListOrg.AddItems("RemarkColor=RGB(000,114,000)")
    ColorListOrg.AddItems("QuotesColor=RGB(160,000,000)")
    ColorListOrg.AddItems("LN_BG_Color=RGB(208,208,208)")
    ColorListOrg.AddItems("LN_FG_Color=RGB(000,000,000)")

Dim KeyWrdLstOrg As QStringList
    KeyWrdLstOrg.AddItems("$APPTYPE")
    KeyWrdLstOrg.AddItems("$DEFINE")
    KeyWrdLstOrg.AddItems("$ELSE")
    KeyWrdLstOrg.AddItems("$ENDIF")
    KeyWrdLstOrg.AddItems("$ESCAPECHARS")
    KeyWrdLstOrg.AddItems("$IFDEF")
    KeyWrdLstOrg.AddItems("$IFNDEF")
    KeyWrdLstOrg.AddItems("$INCLUDE")
    KeyWrdLstOrg.AddItems("$MACRO")
    KeyWrdLstOrg.AddItems("$OPTIMIZE")
    KeyWrdLstOrg.AddItems("$OPTION")
    KeyWrdLstOrg.AddItems("$RESOURCE")
    KeyWrdLstOrg.AddItems("$TYPECHECK")
    KeyWrdLstOrg.AddItems("$UNDEF")
    KeyWrdLstOrg.AddItems("ABS")
    KeyWrdLstOrg.AddItems("ACOS")
    KeyWrdLstOrg.AddItems("APPLICATION")
    KeyWrdLstOrg.AddItems("ASC")
    KeyWrdLstOrg.AddItems("ASIN")
    KeyWrdLstOrg.AddItems("ATAN")
    KeyWrdLstOrg.AddItems("ATN")
    KeyWrdLstOrg.AddItems("BIN$")
    KeyWrdLstOrg.AddItems("BIND")
    KeyWrdLstOrg.AddItems("BYREF")
    KeyWrdLstOrg.AddItems("BYTE")
    KeyWrdLstOrg.AddItems("BYVAL")
    KeyWrdLstOrg.AddItems("CALL")
    KeyWrdLstOrg.AddItems("CALLBACK")
    KeyWrdLstOrg.AddItems("CALLFUNC")
    KeyWrdLstOrg.AddItems("CEIL")
    KeyWrdLstOrg.AddItems("CHDIR")
    KeyWrdLstOrg.AddItems("CHDRIVE")
    KeyWrdLstOrg.AddItems("CHR$")
    KeyWrdLstOrg.AddItems("CINT")
    KeyWrdLstOrg.AddItems("CLIPBOARD")
    KeyWrdLstOrg.AddItems("CLNG")
    KeyWrdLstOrg.AddItems("CLS")
    KeyWrdLstOrg.AddItems("CODEPTR")
    KeyWrdLstOrg.AddItems("COLOR")
    KeyWrdLstOrg.AddItems("COMMAND$")
    KeyWrdLstOrg.AddItems("COMMANDCOUNT")
    KeyWrdLstOrg.AddItems("CONSOLE.INPUTHANDLE")
    KeyWrdLstOrg.AddItems("CONSOLE.OUTPUTHANDLE")
    KeyWrdLstOrg.AddItems("CONST")
    KeyWrdLstOrg.AddItems("CONSTRUCTOR")
    KeyWrdLstOrg.AddItems("CONVBASE$")
    KeyWrdLstOrg.AddItems("COS")
    KeyWrdLstOrg.AddItems("CREATE")
    KeyWrdLstOrg.AddItems("CSRLIN")
    KeyWrdLstOrg.AddItems("CURDIR$")
    KeyWrdLstOrg.AddItems("DATA")
    KeyWrdLstOrg.AddItems("DATE$")
    KeyWrdLstOrg.AddItems("DEC")
    KeyWrdLstOrg.AddItems("DEFBYTE")
    KeyWrdLstOrg.AddItems("DEFDBL")
    KeyWrdLstOrg.AddItems("DEFDWORD")
    KeyWrdLstOrg.AddItems("DEFINT")
    KeyWrdLstOrg.AddItems("DEFLNG")
    KeyWrdLstOrg.AddItems("DEFSHORT")
    KeyWrdLstOrg.AddItems("DEFSNG")
    KeyWrdLstOrg.AddItems("DEFSTR")
    KeyWrdLstOrg.AddItems("DEFWORD")
    KeyWrdLstOrg.AddItems("DELETE$")
    KeyWrdLstOrg.AddItems("DIM")
    KeyWrdLstOrg.AddItems("DIR$")
    KeyWrdLstOrg.AddItems("DIREXISTS")
    KeyWrdLstOrg.AddItems("DO")
    KeyWrdLstOrg.AddItems("DOEVENTS")
    KeyWrdLstOrg.AddItems("DOUBLE")
    KeyWrdLstOrg.AddItems("DWORD")
    KeyWrdLstOrg.AddItems("ELSE")
    KeyWrdLstOrg.AddItems("ELSEIF")
    KeyWrdLstOrg.AddItems("ENVIRON")
    KeyWrdLstOrg.AddItems("ENVIRON$")
    KeyWrdLstOrg.AddItems("EVENT")
    KeyWrdLstOrg.AddItems("EXECUTE")
    KeyWrdLstOrg.AddItems("EXP")
    KeyWrdLstOrg.AddItems("EXTRACTRESOURCE")
    KeyWrdLstOrg.AddItems("FIELD$")
    KeyWrdLstOrg.AddItems("FILEEXISTS")
    KeyWrdLstOrg.AddItems("FIX")
    KeyWrdLstOrg.AddItems("FLOOR")
    KeyWrdLstOrg.AddItems("FOR")
    KeyWrdLstOrg.AddItems("FORMAT$")
    KeyWrdLstOrg.AddItems("FRAC")
    KeyWrdLstOrg.AddItems("FUNCTION")
    KeyWrdLstOrg.AddItems("FUNCTIONI")
    KeyWrdLstOrg.AddItems("GET$")
    KeyWrdLstOrg.AddItems("GOSUB")
    KeyWrdLstOrg.AddItems("GOTO")
    KeyWrdLstOrg.AddItems("HEX$")
    KeyWrdLstOrg.AddItems("IF")
    KeyWrdLstOrg.AddItems("IIF")
    KeyWrdLstOrg.AddItems("INC")
    KeyWrdLstOrg.AddItems("INITARRAY")
    KeyWrdLstOrg.AddItems("INKEY$")
    KeyWrdLstOrg.AddItems("INP")
    KeyWrdLstOrg.AddItems("INPUT")
    KeyWrdLstOrg.AddItems("INPUT$")
    KeyWrdLstOrg.AddItems("INPW")
    KeyWrdLstOrg.AddItems("INSERT$")
    KeyWrdLstOrg.AddItems("INSTR")
    KeyWrdLstOrg.AddItems("INT")
    KeyWrdLstOrg.AddItems("INTEGER")
    KeyWrdLstOrg.AddItems("ISCONSOLE")
    KeyWrdLstOrg.AddItems("KILL")
    KeyWrdLstOrg.AddItems("KILLMESSAGE")
    KeyWrdLstOrg.AddItems("LBOUND")
    KeyWrdLstOrg.AddItems("LCASE$")
    KeyWrdLstOrg.AddItems("LEFT$")
    KeyWrdLstOrg.AddItems("LEN")
    KeyWrdLstOrg.AddItems("LFLUSH")
    KeyWrdLstOrg.AddItems("LIB")
    KeyWrdLstOrg.AddItems("LIBRARYINST")
    KeyWrdLstOrg.AddItems("LOCATE")
    KeyWrdLstOrg.AddItems("LOG")
    KeyWrdLstOrg.AddItems("LONG")
    KeyWrdLstOrg.AddItems("LOOP")
    KeyWrdLstOrg.AddItems("LPRINT")
    KeyWrdLstOrg.AddItems("LTRIM$")
    KeyWrdLstOrg.AddItems("MEMCMP")
    KeyWrdLstOrg.AddItems("MEMCPY")
    KeyWrdLstOrg.AddItems("MEMSET")
    KeyWrdLstOrg.AddItems("MESSAGEBOX")
    KeyWrdLstOrg.AddItems("MESSAGEDLG")
    KeyWrdLstOrg.AddItems("MID$")
    KeyWrdLstOrg.AddItems("MKDIR")
    KeyWrdLstOrg.AddItems("MOUSEX")
    KeyWrdLstOrg.AddItems("MOUSEY")
    KeyWrdLstOrg.AddItems("NEXT")
    KeyWrdLstOrg.AddItems("OUT")
    KeyWrdLstOrg.AddItems("OUTW")
    KeyWrdLstOrg.AddItems("PARAMSTR$")
    KeyWrdLstOrg.AddItems("PARAMSTRCOUNT")
    KeyWrdLstOrg.AddItems("PARAMVAL")
    KeyWrdLstOrg.AddItems("PARAMVALCOUNT")
    KeyWrdLstOrg.AddItems("PCOPY")
    KeyWrdLstOrg.AddItems("PEEK")
    KeyWrdLstOrg.AddItems("PLAYWAV")
    KeyWrdLstOrg.AddItems("POKE")
    KeyWrdLstOrg.AddItems("POS")
    KeyWrdLstOrg.AddItems("POSTMESSAGE")
    KeyWrdLstOrg.AddItems("PRINT")
    KeyWrdLstOrg.AddItems("PRINTER")
    KeyWrdLstOrg.AddItems("PROPERTY")
    KeyWrdLstOrg.AddItems("QBITMAP")
    KeyWrdLstOrg.AddItems("QBUTTON")
    KeyWrdLstOrg.AddItems("QCANVAS")
    KeyWrdLstOrg.AddItems("QCHECKBOX")
    KeyWrdLstOrg.AddItems("QCOMBOBOX")
    KeyWrdLstOrg.AddItems("QCOMPORT")
    KeyWrdLstOrg.AddItems("QCOOLBTN")
    KeyWrdLstOrg.AddItems("QD3DFACE")
    KeyWrdLstOrg.AddItems("QD3DFRAME")
    KeyWrdLstOrg.AddItems("QD3DLIGHT")
    KeyWrdLstOrg.AddItems("QD3DMESH")
    KeyWrdLstOrg.AddItems("QD3DMESHBUILDER")
    KeyWrdLstOrg.AddItems("QD3DTEXTURE")
    KeyWrdLstOrg.AddItems("QD3DVECTOR")
    KeyWrdLstOrg.AddItems("QD3DVISUAL")
    KeyWrdLstOrg.AddItems("QD3DWRAP")
    KeyWrdLstOrg.AddItems("QDIRTREE")
    KeyWrdLstOrg.AddItems("QDXIMAGELIST")
    KeyWrdLstOrg.AddItems("QDXSCREEN")
    KeyWrdLstOrg.AddItems("QDXSOUND")
    KeyWrdLstOrg.AddItems("QDXTIMER")
    KeyWrdLstOrg.AddItems("QEDIT")
    KeyWrdLstOrg.AddItems("QFILELISTBOX")
    KeyWrdLstOrg.AddItems("QFILESTREAM")
    KeyWrdLstOrg.AddItems("QFONT")
    KeyWrdLstOrg.AddItems("QFONTDIALOG")
    KeyWrdLstOrg.AddItems("QFORM")
    KeyWrdLstOrg.AddItems("QGAUGE")
    KeyWrdLstOrg.AddItems("QGLASSFRAME")
    KeyWrdLstOrg.AddItems("QGROUPBOX")
    KeyWrdLstOrg.AddItems("QHEADER")
    KeyWrdLstOrg.AddItems("QIMAGE")
    KeyWrdLstOrg.AddItems("QIMAGELIST")
    KeyWrdLstOrg.AddItems("QLABEL")
    KeyWrdLstOrg.AddItems("QLISTBOX")
    KeyWrdLstOrg.AddItems("QLISTVIEW")
    KeyWrdLstOrg.AddItems("QMAINMENU")
    KeyWrdLstOrg.AddItems("QMEMORYSTREAM")
    KeyWrdLstOrg.AddItems("QMENUITEM")
    KeyWrdLstOrg.AddItems("QMYSQL")
    KeyWrdLstOrg.AddItems("QNOTIFYICONDATA")
    KeyWrdLstOrg.AddItems("QOBJECT")
    KeyWrdLstOrg.AddItems("QOLECONTAINER")
    KeyWrdLstOrg.AddItems("QOLEOBJECT")
    KeyWrdLstOrg.AddItems("QOPENDIALOG")
    KeyWrdLstOrg.AddItems("QOUTLINE")
    KeyWrdLstOrg.AddItems("QOVALBTN")
    KeyWrdLstOrg.AddItems("QPANEL")
    KeyWrdLstOrg.AddItems("QPOPUPMENU")
    KeyWrdLstOrg.AddItems("QRADIOBUTTON")
    KeyWrdLstOrg.AddItems("QRECT")
    KeyWrdLstOrg.AddItems("QREGISTRY")
    KeyWrdLstOrg.AddItems("QRICHEDIT")
    KeyWrdLstOrg.AddItems("QSAVEDIALOG")
    KeyWrdLstOrg.AddItems("QSCROLLBAR")
    KeyWrdLstOrg.AddItems("QSCROLLBOX")
    KeyWrdLstOrg.AddItems("QSOCKET")
    KeyWrdLstOrg.AddItems("QSPLITTER")
    KeyWrdLstOrg.AddItems("QSTATUSBAR")
    KeyWrdLstOrg.AddItems("QSTRINGGRID")
    KeyWrdLstOrg.AddItems("QSTRINGLIST")
    KeyWrdLstOrg.AddItems("QTABCONTROL")
    KeyWrdLstOrg.AddItems("QTIMER")
    KeyWrdLstOrg.AddItems("QTRACKBAR")
    KeyWrdLstOrg.AddItems("QTREEVIEW")
    KeyWrdLstOrg.AddItems("QUICKSORT")
    KeyWrdLstOrg.AddItems("RANDOMIZE")
    KeyWrdLstOrg.AddItems("READ")
    KeyWrdLstOrg.AddItems("REDIM")
    KeyWrdLstOrg.AddItems("REM")
    KeyWrdLstOrg.AddItems("RENAME")
    KeyWrdLstOrg.AddItems("REPLACE$")
    KeyWrdLstOrg.AddItems("REPLACESUBSTR$")
    KeyWrdLstOrg.AddItems("RESOURCE")
    KeyWrdLstOrg.AddItems("RESOURCECOUNT")
    KeyWrdLstOrg.AddItems("RESTORE")
    KeyWrdLstOrg.AddItems("RETURN")
    KeyWrdLstOrg.AddItems("REVERSE$")
    KeyWrdLstOrg.AddItems("RGB")
    KeyWrdLstOrg.AddItems("RIGHT$")
    KeyWrdLstOrg.AddItems("RINSTR")
    KeyWrdLstOrg.AddItems("RMDIR")
    KeyWrdLstOrg.AddItems("RND")
    KeyWrdLstOrg.AddItems("ROUND")
    KeyWrdLstOrg.AddItems("RTRIM$")
    KeyWrdLstOrg.AddItems("RUN")
    KeyWrdLstOrg.AddItems("SCREEN")
    KeyWrdLstOrg.AddItems("SCREEN.CONSOLEX")
    KeyWrdLstOrg.AddItems("SCREEN.CONSOLEY")
    KeyWrdLstOrg.AddItems("SCREEN.CURSOR")
    KeyWrdLstOrg.AddItems("SCREEN.CURSORS")
    KeyWrdLstOrg.AddItems("SCREEN.HEIGHT")
    KeyWrdLstOrg.AddItems("SCREEN.MOUSEX")
    KeyWrdLstOrg.AddItems("SCREEN.MOUSEY")
    KeyWrdLstOrg.AddItems("SCREEN.WIDTH")
    KeyWrdLstOrg.AddItems("SELECT")
    KeyWrdLstOrg.AddItems("SENDMESSAGE")
    KeyWrdLstOrg.AddItems("SETCONSOLETITLE")
    KeyWrdLstOrg.AddItems("SGN")
    KeyWrdLstOrg.AddItems("SHELL")
    KeyWrdLstOrg.AddItems("SHORT")
    KeyWrdLstOrg.AddItems("SHOWMESSAGE")
    KeyWrdLstOrg.AddItems("SIN")
    KeyWrdLstOrg.AddItems("SINGLE")
    KeyWrdLstOrg.AddItems("SIZEOF")
    KeyWrdLstOrg.AddItems("SLEEP")
    KeyWrdLstOrg.AddItems("SOUND")
    KeyWrdLstOrg.AddItems("SPACE$")
    KeyWrdLstOrg.AddItems("SQR")
    KeyWrdLstOrg.AddItems("STACK.INT")
    KeyWrdLstOrg.AddItems("STACK.STR$")
    KeyWrdLstOrg.AddItems("STATIC")
    KeyWrdLstOrg.AddItems("STEP")
    KeyWrdLstOrg.AddItems("STR$")
    KeyWrdLstOrg.AddItems("STRF$")
    KeyWrdLstOrg.AddItems("STRING")
    KeyWrdLstOrg.AddItems("STRING$")
    KeyWrdLstOrg.AddItems("STRUCT")
    KeyWrdLstOrg.AddItems("SUB")
    KeyWrdLstOrg.AddItems("SUBI")
    KeyWrdLstOrg.AddItems("SWAP")
    KeyWrdLstOrg.AddItems("TALLY")
    KeyWrdLstOrg.AddItems("TAN")
    KeyWrdLstOrg.AddItems("THEN")
    KeyWrdLstOrg.AddItems("TIME$")
    KeyWrdLstOrg.AddItems("TIMER")
    KeyWrdLstOrg.AddItems("TYPE")
    KeyWrdLstOrg.AddItems("UBOUND")
    KeyWrdLstOrg.AddItems("UCASE$")
    KeyWrdLstOrg.AddItems("UNLOADLIBRARY")
    KeyWrdLstOrg.AddItems("VAL")
    KeyWrdLstOrg.AddItems("VARIANT")
    KeyWrdLstOrg.AddItems("VARPTR")
    KeyWrdLstOrg.AddItems("VARPTR$")
    KeyWrdLstOrg.AddItems("VARTYPE")
    KeyWrdLstOrg.AddItems("WEND")
    KeyWrdLstOrg.AddItems("WHILE")
    KeyWrdLstOrg.AddItems("WITH")
    KeyWrdLstOrg.AddItems("WORD")

Dim ExtWrdLstOrg As QStringList
    ExtWrdLstOrg.AddItems("ALIAS")
    ExtWrdLstOrg.AddItems("AND")
    ExtWrdLstOrg.AddItems("AS")
    ExtWrdLstOrg.AddItems("CASE")
    ExtWrdLstOrg.AddItems("DECLARE")
    ExtWrdLstOrg.AddItems("END")
    ExtWrdLstOrg.AddItems("EXIT")
    ExtWrdLstOrg.AddItems("EXTENDS")
    ExtWrdLstOrg.AddItems("INV")
    ExtWrdLstOrg.AddItems("IS")
    ExtWrdLstOrg.AddItems("MOD")
    ExtWrdLstOrg.AddItems("NOT")
    ExtWrdLstOrg.AddItems("OR")
    ExtWrdLstOrg.AddItems("RESULT")
    ExtWrdLstOrg.AddItems("SHL")
    ExtWrdLstOrg.AddItems("SHR")
    ExtWrdLstOrg.AddItems("TO")
    ExtWrdLstOrg.AddItems("UNTIL")
    ExtWrdLstOrg.AddItems("XOR")

Dim KeyWordsList As QStringList
    KeyWordsList.AddItems(CommentsOrg.Text,"")
    KeyWordsList.AddItems("[Colors]")
    For HL_Idx = 0 To (ColorListOrg.ItemCount-1)
      KeyWordsList.AddItems(ColorListOrg.Item(HL_Idx))
    Next
    KeyWordsList.AddItems("")
    KeyWordsList.AddItems("[KeyWrds]")
    For HL_Idx = 0 To (KeyWrdLstOrg.ItemCount-1)
      KeyWordsList.AddItems(KeyWrdLstOrg.Item(HL_Idx))
    Next
    KeyWordsList.AddItems("")
    KeyWordsList.AddItems("[ExtWrds]")
    For HL_Idx = 0 To (ExtWrdLstOrg.ItemCount-1)
      KeyWordsList.AddItems(ExtWrdLstOrg.Item(HL_Idx))
    Next
    KeyWordsList.AddItems("")

Create EAE_Form As QForm
  BorderStyle = bsSingle
  DelBorderIcons(biMinimize, biMaximize)
  Caption = " EditAide Editor"
  Width = 418
  Height = 368
  Center
  Color = RGB(202,200,196)
  OnShow = EAE_SetUp
  OnClose = EAE_Exit
  Create EditorRestoreDefaults As QButton
    Left = 5
    Top = 5
    Width = 132
    Height = 25
    Caption = "Restore Defaults"
    OnClick = RestoreDefaults
    Enabled = False
  End Create
  Create EditorSaveNewDefaults As QButton
    Left = 140
    Top = 5
    Width = 132
    Height = 25
    Caption = "Save and Exit"
    OnClick = EAE_SaveNewDefaultsExit
    Enabled = False
  End Create
  Create EditorExitWithoutSave As QButton
    Left = 276
    Top = 5
    Width = 132
    Height = 25
    Caption = "Exit"
    OnClick = EAE_Exit
  End Create
  Create wrdPanel As QPanel
    Left = 5
    Top = 35
    Width = 404
    Height = 186
    BorderStyle = bsNone
    Create wrdLabel1 As QLabel
      AutoSize = False
      Left = 10
      Top = 8
      Width = 150
      Height = 16
      Alignment = taCenter
      Font.Name = "FixedSys"
      Caption = "KeyWords"
    End Create
    Create wrdListBox1 As QListBox
      Left = 10
      Top = 26
      Width = 150
      Height = 85
      Sorted = 1
      MultiSelect = True
      OnClick = KeyToExt
    End Create
    Create wrdLabel2 As QLabel
      AutoSize = False
      Left = 250
      Top = 8
      Width = 150
      Height = 16
      Alignment = taCenter
      Font.Name = "FixedSys"
      Caption = "ExtensionWords"
    End Create
    Create wrdListBox2 As QListBox
      Left = 250
      Top = 26
      Width = 150
      Height = 85
      Sorted = 1
      MultiSelect = True
      OnClick = ExtToKey
    End Create
    Create wrdButton1 As QButton
      Caption = "<---  Move"
      Left = 167
      Top = 26
      Width = 76
      Height = 25
      Enabled = False
      OnClick = MoveExtToKey
    End Create
    Create wrdButton2 As QButton
      Caption = "  Delete  "
      Left = 167
      Top = 56
      Width = 76
      Height = 25
      Enabled = False
      OnClick = DelWrd
    End Create
    Create wrdButton3 As QButton
      Caption = "Move  --->"
      Left = 167
      Top = 86
      Width = 76
      Height = 25
      Enabled = False
      OnClick = MoveKeyToExt
    End Create
    Create wrdButton4 As QButton
      Caption = "New KeyWord"
      Left = 10
      Top = 122
      Width = 150
      Height = 25
      Enabled = False
      OnClick = AddKeyWrd
    End Create
    Create wrdEdit1 As QEdit
      AutoSize = False
      Left = 10
      Top = 152
      Width = 150
      Height = 21
      Text = ""
      OnChange = KeyWrdAddChk
    End Create
    Create wrdLabel3 As QLabel
      AutoSize = False
      Transparent = True
      Left = 163
      Top = 130
      Width = 82
      Height = 16
      Alignment = taCenter
      Font.Name = "FixedSys"
      Font.Bold = True
      Caption = "<-     ->"
    End Create
    Create wrdLabel4 As QLabel
      AutoSize = False
      Transparent = True
      Left = 163
      Top = 135
      Width = 82
      Height = 16
      Alignment = taCenter
      Font.Name = "FixedSys"
      Caption = "  |     |  "
    End Create
    Create wrdLabel5 As QLabel
      AutoSize = False
      Transparent = True
      Left = 163
      Top = 144
      Width = 82
      Height = 16
      Alignment = taCenter
      Font.Name = "FixedSys"
      Caption = "  |-ADD-|  "
    End Create
    Create wrdLabel6 As QLabel
      AutoSize = False
      Transparent = True
      Left = 163
      Top = 150
      Width = 82
      Height = 16
      Alignment = taCenter
      Font.Name = "FixedSys"
      Caption = "  |     |  "
    End Create
    Create wrdLabel7 As QLabel
      AutoSize = False
      Transparent = True
      Left = 163
      Top = 158
      Width = 82
      Height = 16
      Alignment = taCenter
      Font.Name = "FixedSys"
      Font.Bold = True
      Caption = "<-     ->"
    End Create
    Create wrdButton5 As QButton
      Caption = "New ExtensionWord"
      Left = 250
      Top = 122
      Width = 150
      Height = 25
      Enabled = False
      OnClick = AddExtWrd
    End Create
    Create wrdEdit2 As QEdit
      AutoSize = False
      Left = 250
      Top = 152
      Width = 150
      Height = 21
      Text = ""
      OnChange = ExtWrdAddChk
    End Create
  End Create
  Create clrPanel As QPanel
    Top     = 226
    Left    = 5
    Width   = 404
    Height  = 106
    Create clrLabel1 As QLabel
      AutoSize = False
      Left = 20
      Top = 16
      Width = 65
      Height = 13
      Alignment = taRightJustify
      Font.Name = "FixedSys"
      Caption = "KeyWrds:"
    End Create
    Create clrPanel1 As QPanel
      Left = 90
      Top = 10
      Width = 90
      Height = 25
      Font.Name = "Arial"
      Font.Size = 9
      Font.Bold = True
      Font.Color = RGB(255,255,255)
      Caption = "Click Me"
      OnClick = ChgPanelClr
    End Create
    Create clrLabel2 As QLabel
      AutoSize = False
      Left = 210
      Top = 16
      Width = 65
      Height = 13
      Alignment = taRightJustify
      Font.Name = "FixedSys"
      Caption = "ExtWrds:"
    End Create
    Create clrPanel2 As QPanel
      Left = 280
      Top = 10
      Width = 90
      Height = 25
      Font.Name = "Arial"
      Font.Size = 9
      Font.Bold = True
      Font.Color = RGB(255,255,255)
      Caption = "Click Me"
      OnClick = ChgPanelClr
    End Create
    Create clrLabel3 As QLabel
      AutoSize = False
      Left = 20
      Top = 46
      Width = 65
      Height = 13
      Alignment = taRightJustify
      Font.Name = "FixedSys"
      Caption = "Remarks:"
    End Create
    Create clrPanel3 As QPanel
      Left = 90
      Top = 40
      Width = 90
      Height = 25
      Font.Name = "Arial"
      Font.Size = 9
      Font.Bold = True
      Font.Color = RGB(255,255,255)
      Caption = "Click Me"
      OnClick = ChgPanelClr
    End Create
    Create clrLabel4 As QLabel
      AutoSize = False
      Left = 210
      Top = 46
      Width = 65
      Height = 13
      Alignment = taRightJustify
      Font.Name = "FixedSys"
      Caption = "Quotes:"
    End Create
    Create clrPanel4 As QPanel
      Left = 280
      Top = 40
      Width = 90
      Height = 25
      Font.Name = "Arial"
      Font.Size = 9
      Font.Bold = True
      Font.Color = RGB(255,255,255)
      Caption = "Click Me"
      OnClick = ChgPanelClr
    End Create
    Create clrLabel5 As QLabel
      AutoSize = False
      Left = 10
      Top = 76
      Width = 75
      Height = 13
      Alignment = taRightJustify
      Font.Name = "FixedSys"
      Caption = "Line# BG:"
    End Create
    Create clrPanel5 As QPanel
      Left = 90
      Top = 70
      Width = 90
      Height = 25
      Font.Name = "Arial"
      Font.Size = 9
      Font.Bold = True
      Font.Color = RGB(255,255,255)
      Caption = "Click Me"
      OnClick = ChgPanelClr
    End Create
    Create clrLabel6 As QLabel
      AutoSize = False
      Left = 200
      Top = 76
      Width = 75
      Height = 13
      Alignment = taRightJustify
      Font.Name = "FixedSys"
      Caption = "Line# FG:"
    End Create
    Create clrPanel6 As QPanel
      Left = 280
      Top = 70
      Width = 90
      Height = 25
      Font.Name = "Arial"
      Font.Size = 9
      Font.Bold = True
      Font.Color = RGB(255,255,255)
      Caption = "Click Me"
      OnClick = ChgPanelClr
    End Create
  End Create
End Create

Sub EAE_Edit(ByVal hWnd_RE As Long, ByVal sStr_KeyWrdFile As String)
    EAE_hWndRE = hWnd_RE
    EAE_KeyWrdFile = sStr_KeyWrdFile
    EAE_InstallPath = Left$(EAE_KeyWrdFile, rInStr(EAE_KeyWrdFile, "\"))
    EAE_Chk = 0
    If EAE_Form.ShowModal = mrOk Then
    If Right$(EAE_Form.Caption,1)="*" Then
      If MessageDlg("Changes have been made!" + EAE_LF + _
                    "          Please Confirm!" + EAE_LF + EAE_LF + _
                    " Save Changes?", mtWarning, mbYes Or mbNo, 0) = mrYes Then EAE_Save(EAE_KeyWrdFile)
    End If
    End If
    If FileExists(EAE_InstallPath + "TmpKeyWrd.lst") Then Kill(EAE_InstallPath + "TmpKeyWrd.lst")
    EAE_Chk = EA_StartUp(hWnd_RE, EAE_KeyWrdFile)
    EAE_SetFocus(hWnd_RE)
End Sub

Sub EAE_SetUp
    LoadFileList.Clear : ModifiedList.Clear
    ColorListDef.Clear : KeyWrdLstDef.Clear : ExtWrdLstDef.Clear
    wrdListBox1.Clear : wrdListBox2.Clear
    EditorRestoreDefaults.Enabled = False
    EAE_Form.Caption = " EditAide Editor"
    KeyWrdClrOrg = RGB(000,000,150)
    ExtWrdClrOrg = RGB(144,000,144)
    RemarkClrOrg = RGB(000,114,000)
    QuotesClrOrg = RGB(160,000,000)
    LN_BG_ClrOrg = RGB(208,208,208)
    LN_FG_ClrOrg = RGB(000,000,000)
    TCC.CustColors(1) = KeyWrdClrOrg
    TCC.CustColors(2) = ExtWrdClrOrg
    TCC.CustColors(3) = RemarkClrOrg
    TCC.CustColors(4) = QuotesClrOrg
    TCC.CustColors(5) = LN_BG_ClrOrg
    TCC.CustColors(6) = LN_FG_ClrOrg
    If FileExists(EAE_KeyWrdFile) Then
      LoadFileList.LoadFromFile(EAE_KeyWrdFile)
      If LoadFileList.Find("[ExtWrds]") <> -1 Then
        HL_N = LoadFileList.IndexOf("[ExtWrds]") + 1
        While HL_N < LoadFileList.ItemCount
          If LoadFileList.Item(HL_N) <> "" Then
            wrdListBox2.AddItems(LoadFileList.Item(HL_N))
            ExtWrdLstDef.AddItems(LoadFileList.Item(HL_N))
          End If
          INC(HL_N)
        Wend
      End If
      If LoadFileList.Find("[KeyWrds]") <> -1 Then
        HL_N = LoadFileList.IndexOf("[KeyWrds]") + 1
        While LoadFileList.Item(HL_N) <> ""
          wrdListBox1.AddItems(LoadFileList.Item(HL_N))
          KeyWrdLstDef.AddItems(LoadFileList.Item(HL_N))
          INC(HL_N)
        Wend
      End If
      If LoadFileList.Find("[Colors]") <> -1 Then
        HL_N = LoadFileList.IndexOf("[Colors]") + 1
        While LoadFileList.Item(HL_N) <> ""
          ColorListDef.AddItems(LoadFileList.Item(HL_N))
          INC(HL_N)
        Wend
        KeyWrdClrDef = RGB(Val(Mid$(ColorListDef.Item(0), InStr(ColorListDef.Item(0),"(")+1, 3)), _
                           Val(Mid$(ColorListDef.Item(0), InStr(ColorListDef.Item(0),",")+1, 3)), _
                           Val(Mid$(ColorListDef.Item(0), rInStr(ColorListDef.Item(0),",")+1, 3)))

        ExtWrdClrDef = RGB(Val(Mid$(ColorListDef.Item(1), InStr(ColorListDef.Item(1),"(")+1, 3)), _
                           Val(Mid$(ColorListDef.Item(1), InStr(ColorListDef.Item(1),",")+1, 3)), _
                           Val(Mid$(ColorListDef.Item(1), rInStr(ColorListDef.Item(1),",")+1, 3)))

        RemarkClrDef = RGB(Val(Mid$(ColorListDef.Item(2), InStr(ColorListDef.Item(2),"(")+1, 3)), _
                           Val(Mid$(ColorListDef.Item(2), InStr(ColorListDef.Item(2),",")+1, 3)), _
                           Val(Mid$(ColorListDef.Item(2), rInStr(ColorListDef.Item(2),",")+1, 3)))

        QuotesClrDef = RGB(Val(Mid$(ColorListDef.Item(3), InStr(ColorListDef.Item(3),"(")+1, 3)), _
                           Val(Mid$(ColorListDef.Item(3), InStr(ColorListDef.Item(3),",")+1, 3)), _
                           Val(Mid$(ColorListDef.Item(3), rInStr(ColorListDef.Item(3),",")+1, 3)))

        LN_BG_ClrDef = RGB(Val(Mid$(ColorListDef.Item(4), InStr(ColorListDef.Item(4),"(")+1, 3)), _
                           Val(Mid$(ColorListDef.Item(4), InStr(ColorListDef.Item(4),",")+1, 3)), _
                           Val(Mid$(ColorListDef.Item(4), rInStr(ColorListDef.Item(4),",")+1, 3)))

        LN_FG_ClrDef = RGB(Val(Mid$(ColorListDef.Item(5), InStr(ColorListDef.Item(5),"(")+1, 3)), _
                           Val(Mid$(ColorListDef.Item(5), InStr(ColorListDef.Item(5),",")+1, 3)), _
                           Val(Mid$(ColorListDef.Item(5), rInStr(ColorListDef.Item(5),",")+1, 3)))
        clrPanel1.Color = KeyWrdClrDef
        clrPanel2.Color = ExtWrdClrDef
        clrPanel3.Color = RemarkClrDef
        clrPanel4.Color = QuotesClrDef
        clrPanel5.Color = LN_BG_ClrDef
        clrPanel6.Color = LN_FG_ClrDef
      End If
    Else
      LoadedFromFile = False
    End If
    If KeyWrdLstDef.Text = "" And ExtWrdLstDef.Text = "" And ColorListDef.Text = "" Then
      LoadedFromFile = False
    Else
      LoadedFromFile = True
    End If
    If LoadedFromFile = False Then
      LoadFileList.Text = KeyWordsList.Text
      wrdListBox1.Text = KeyWrdLstOrg.Text
      wrdListBox2.Text = ExtWrdLstOrg.Text
      KeyWrdLstDef.Text = KeyWrdLstOrg.Text
      ExtWrdLstDef.Text = ExtWrdLstOrg.Text
      clrPanel1.Color = KeyWrdClrOrg
      clrPanel2.Color = ExtWrdClrOrg
      clrPanel3.Color = RemarkClrOrg
      clrPanel4.Color = QuotesClrOrg
      clrPanel5.Color = LN_BG_ClrOrg
      clrPanel6.Color = LN_FG_ClrOrg
      KeyWrdClrDef = KeyWrdClrOrg
      ExtWrdClrDef = ExtWrdClrOrg
      RemarkClrDef = RemarkClrOrg
      QuotesClrDef = QuotesClrOrg
      LN_BG_ClrDef = LN_BG_ClrOrg
      LN_FG_ClrDef = LN_FG_ClrOrg
      LoadFileList.SaveToFile(EAE_KeyWrdFile)
    End If
    Grab_RGB_HLS(clrPanel1)
    clrPanel1.Font.Color = IIF((EAE_lLum <= 180) And ((EAE_lHue + EAE_lSat) <= 460) And (HL_Green < 255), RGB(255,255,255), RGB(000,000,000))
    Grab_RGB_HLS(clrPanel2)
    clrPanel2.Font.Color = IIF((EAE_lLum <= 180) And ((EAE_lHue + EAE_lSat) <= 460) And (HL_Green < 255), RGB(255,255,255), RGB(000,000,000))
    Grab_RGB_HLS(clrPanel3)
    clrPanel3.Font.Color = IIF((EAE_lLum <= 180) And ((EAE_lHue + EAE_lSat) <= 460) And (HL_Green < 255), RGB(255,255,255), RGB(000,000,000))
    Grab_RGB_HLS(clrPanel4)
    clrPanel4.Font.Color = IIF((EAE_lLum <= 180) And ((EAE_lHue + EAE_lSat) <= 460) And (HL_Green < 255), RGB(255,255,255), RGB(000,000,000))
    Grab_RGB_HLS(clrPanel5)
    clrPanel5.Font.Color = IIF((EAE_lLum <= 180) And ((EAE_lHue + EAE_lSat) <= 460) And (HL_Green < 255), RGB(255,255,255), RGB(000,000,000))
    Grab_RGB_HLS(clrPanel6)
    clrPanel6.Font.Color = IIF((EAE_lLum <= 180) And ((EAE_lHue + EAE_lSat) <= 460) And (HL_Green < 255), RGB(255,255,255), RGB(000,000,000))
    EAE_SetFocus(EditorSaveNewDefaults.Handle)
End Sub

Sub EAE_SaveNewDefaultsExit
    EAE_Save(EAE_KeyWrdFile)
    EAE_Form.Caption = " EditAide Editor"
    EAE_Form.ModalResult = mrOk
End Sub

Sub EAE_Exit
    EAE_Form.ModalResult = mrOk
End Sub

Sub EAE_Save(ByVal sStr_KeyWrdFile As String)
    ModifiedList.Clear
    For HL_Idx = 0 To LoadFileList.IndexOf("[Colors]")
      ModifiedList.AddItems(LoadFileList.Item(HL_Idx))
    Next
    Grab_RGB_HLS(clrPanel1)
    clrPanel1.Font.Color = IIF((EAE_lLum <= 180) And ((EAE_lHue + EAE_lSat) <= 460) And (HL_Green < 255), RGB(255,255,255), RGB(000,000,000))
    ModifiedList.AddItems("KeyWrdColor=RGB("+Format$("%.3d",HL_Red)+","+Format$("%.3d",HL_Green)+","+Format$("%.3d",HL_Blue)+")")
    Grab_RGB_HLS(clrPanel2)
    clrPanel2.Font.Color = IIF((EAE_lLum <= 180) And ((EAE_lHue + EAE_lSat) <= 460) And (HL_Green < 255), RGB(255,255,255), RGB(000,000,000))
    ModifiedList.AddItems("ExtWrdColor=RGB("+Format$("%.3d",HL_Red)+","+Format$("%.3d",HL_Green)+","+Format$("%.3d",HL_Blue)+")")
    Grab_RGB_HLS(clrPanel3)
    clrPanel3.Font.Color = IIF((EAE_lLum <= 180) And ((EAE_lHue + EAE_lSat) <= 460) And (HL_Green < 255), RGB(255,255,255), RGB(000,000,000))
    ModifiedList.AddItems("RemarkColor=RGB("+Format$("%.3d",HL_Red)+","+Format$("%.3d",HL_Green)+","+Format$("%.3d",HL_Blue)+")")
    Grab_RGB_HLS(clrPanel4)
    clrPanel4.Font.Color = IIF((EAE_lLum <= 180) And ((EAE_lHue + EAE_lSat) <= 460) And (HL_Green < 255), RGB(255,255,255), RGB(000,000,000))
    ModifiedList.AddItems("QuotesColor=RGB("+Format$("%.3d",HL_Red)+","+Format$("%.3d",HL_Green)+","+Format$("%.3d",HL_Blue)+")")
    Grab_RGB_HLS(clrPanel5)
    clrPanel5.Font.Color = IIF((EAE_lLum <= 180) And ((EAE_lHue + EAE_lSat) <= 460) And (HL_Green < 255), RGB(255,255,255), RGB(000,000,000))
    ModifiedList.AddItems("LN_BG_Color=RGB("+Format$("%.3d",HL_Red)+","+Format$("%.3d",HL_Green)+","+Format$("%.3d",HL_Blue)+")")
    Grab_RGB_HLS(clrPanel6)
    clrPanel6.Font.Color = IIF((EAE_lLum <= 180) And ((EAE_lHue + EAE_lSat) <= 460) And (HL_Green < 255), RGB(255,255,255), RGB(000,000,000))
    ModifiedList.AddItems("LN_FG_Color=RGB("+Format$("%.3d",HL_Red)+","+Format$("%.3d",HL_Green)+","+Format$("%.3d",HL_Blue)+")")
    ModifiedList.AddItems("","[KeyWrds]")
    For HL_Idx = 0 To wrdListBox1.ItemCount-1
      ModifiedList.AddItems(wrdListBox1.Item(HL_Idx))
    Next
    ModifiedList.AddItems("","[ExtWrds]")
    For HL_Idx = 0 To wrdListBox2.ItemCount-1
      ModifiedList.AddItems(wrdListBox2.Item(HL_Idx))
    Next
    If FileExists(sStr_KeyWrdFile) Then Kill(sStr_KeyWrdFile)
    ModifiedList.SaveToFile(sStr_KeyWrdFile)
    EAE_Chk = EA_StartUp(EAE_hWndRE, sStr_KeyWrdFile)
    EAE_RedrawWindow(EAE_hWndRE, 0, 0, &H1)
    EAE_SetFocus(EditorSaveNewDefaults.Handle)
End Sub

Sub RestoreDefaults
    wrdListBox1.Clear
    wrdListBox1.Text = KeyWrdLstDef.Text
    wrdListBox2.Clear
    wrdListBox2.Text = ExtWrdLstDef.Text
    clrPanel1.Color = KeyWrdClrDef
    clrPanel2.Color = ExtWrdClrDef
    clrPanel3.Color = RemarkClrDef
    clrPanel4.Color = QuotesClrDef
    clrPanel5.Color = LN_BG_ClrDef
    clrPanel6.Color = LN_FG_ClrDef
    EAE_Save(EAE_InstallPath + "TmpKeyWrd.lst")
    EAE_MenuChk
End Sub

Sub KeyToExt
    wrdButton1.Enabled = False
    wrdButton2.Enabled = True
    wrdButton3.Enabled = True
    For HL_Idx = 0 To wrdListBox2.ItemCount-1
      If wrdListBox2.Selected(HL_Idx) Then wrdListBox2.Selected(HL_Idx) = False
    Next
End Sub

Sub ExtToKey
    wrdButton1.Enabled = True
    wrdButton2.Enabled = True
    wrdButton3.Enabled = False
    For HL_Idx = 0 To wrdListBox1.ItemCount-1
      If wrdListBox1.Selected(HL_Idx) Then wrdListBox1.Selected(HL_Idx) = False
    Next
End Sub

Sub MoveKeyToExt
    For HL_Idx = 0 To wrdListBox1.ItemCount-1
      If wrdListBox1.Selected(HL_Idx) Then wrdListBox2.AddItems(wrdListBox1.Item(HL_Idx))
    Next
    For HL_Idx = wrdListBox1.ItemCount-1 To 0 Step -1
      If wrdListBox1.Selected(HL_Idx) Then wrdListBox1.DelItems(HL_Idx)
    Next
    wrdButton2.Enabled = False
    wrdButton3.Enabled = False
    EAE_Save(EAE_InstallPath + "TmpKeyWrd.lst")
    EAE_MenuChk
End Sub

Sub MoveExtToKey
    For HL_Idx = 0 To wrdListBox2.ItemCount-1
      If wrdListBox2.Selected(HL_Idx) Then wrdListBox1.AddItems(wrdListBox2.Item(HL_Idx))
    Next
    For HL_Idx = wrdListBox2.ItemCount-1 To 0 Step -1
      If wrdListBox2.Selected(HL_Idx) Then wrdListBox2.DelItems(HL_Idx)
    Next
    wrdButton1.Enabled = False
    wrdButton2.Enabled = False
    EAE_Save(EAE_InstallPath + "TmpKeyWrd.lst")
    EAE_MenuChk
End Sub

Sub AddKeyWrd
    HL_N = -1
    For HL_Idx = 0 To wrdListBox1.ItemCount - 1
      If wrdListBox1.Item(HL_Idx) = UCASE$(wrdEdit1.Text) Then
        wrdListBox1.TopIndex = HL_Idx
        HL_N = HL_Idx
      End If
    Next
    If HL_N = -1 Then wrdListBox1.AddItems(UCASE$(wrdEdit1.Text))
    wrdEdit1.Text = ""
    wrdButton4.Enabled = False
    EAE_Save(EAE_InstallPath + "TmpKeyWrd.lst")
    EAE_MenuChk
End Sub

Sub AddExtWrd
    HL_N = -1
    For HL_Idx = 0 To wrdListBox2.ItemCount - 1
      If wrdListBox2.Item(HL_Idx) = UCASE$(wrdEdit2.Text) Then
        wrdListBox2.TopIndex = HL_Idx
        HL_N = HL_Idx
      End If
    Next
    If HL_N = -1 Then wrdListBox2.AddItems(UCASE$(wrdEdit2.Text))
    wrdEdit2.Text = ""
    wrdButton5.Enabled = False
    EAE_Save(EAE_InstallPath + "TmpKeyWrd.lst")
    EAE_MenuChk
End Sub

Sub DelWrd
    wrdButton1.Enabled = False
    wrdButton2.Enabled = False
    wrdButton3.Enabled = False
    For HL_Idx = wrdListBox1.ItemCount - 1 To 0 Step -1
      If wrdListBox1.Selected(HL_Idx) Then wrdListBox1.DelItems(HL_Idx)
    Next
    For HL_Idx = wrdListBox2.ItemCount - 1 To 0 Step -1
      If wrdListBox2.Selected(HL_Idx) Then wrdListBox2.DelItems(HL_Idx)
    Next
    EAE_Save(EAE_InstallPath + "TmpKeyWrd.lst")
    EAE_MenuChk
End Sub

Sub KeyWrdAddChk
    wrdButton1.Enabled = False
    wrdButton2.Enabled = False
    wrdButton3.Enabled = False
    wrdButton4.Enabled = IIF(wrdEdit1.Text="",False,True)
    For HL_Idx = 0 To wrdListBox1.ItemCount-1
      If wrdListBox1.Selected(HL_Idx) Then wrdListBox1.Selected(HL_Idx) = False
    Next
    For HL_Idx = 0 To wrdListBox2.ItemCount-1
      If wrdListBox2.Selected(HL_Idx) Then wrdListBox2.Selected(HL_Idx) = False
    Next
End Sub

Sub ExtWrdAddChk
    wrdButton1.Enabled = False
    wrdButton2.Enabled = False
    wrdButton3.Enabled = False
    wrdButton5.Enabled = IIF(wrdEdit2.Text="",False,True)
    For HL_Idx = 0 To wrdListBox1.ItemCount-1
      If wrdListBox1.Selected(HL_Idx) Then wrdListBox1.Selected(HL_Idx) = False
    Next
    For HL_Idx = 0 To wrdListBox2.ItemCount-1
      If wrdListBox2.Selected(HL_Idx) Then wrdListBox2.Selected(HL_Idx) = False
    Next
End Sub

Sub ChgPanelClr(Sender As QPanel)
    PanelColor = Sender.Color
    TCC.lStructSize = SizeOf(TCC)
    TCC.hWndOwner = Sender.Handle
    TCC.rgbResult = PanelColor
    TCC.Flags = &H1 + &H2
    HL_lRetCC = EAE_ChooseClrDlg(TCC)
    If HL_lRetCC <> 0 Then
      PanelColor = TCC.rgbResult
      Sender.Color = PanelColor
      EAE_Save(EAE_InstallPath + "TmpKeyWrd.lst")
      EAE_MenuChk
    End If
End Sub

Sub EAE_MenuChk
    If wrdListBox1.Text = KeyWrdLstDef.Text And _
       wrdListBox2.Text = ExtWrdLstDef.Text And _
       clrPanel1.Color = KeyWrdClrDef And _
       clrPanel2.Color = ExtWrdClrDef And _
       clrPanel3.Color = RemarkClrDef And _
       clrPanel4.Color = QuotesClrDef And _
       clrPanel5.Color = LN_BG_ClrDef And _
       clrPanel6.Color = LN_FG_ClrDef Then
       EditorRestoreDefaults.Enabled = False
       EditorSaveNewDefaults.Enabled = False
    Else
       EditorRestoreDefaults.Enabled = True
       EditorSaveNewDefaults.Enabled = True
    End If
    If EditorRestoreDefaults.Enabled = False Then
       EAE_Form.Caption = " EditAide Editor"
    Else
       EAE_Form.Caption = " EditAide Editor *"
    End If
End Sub

Sub Grab_RGB_HLS(Sender As QPanel)
    HL_Blue = Floor(Sender.Color / 65536)
    HL_Green = Floor((Sender.Color - (HL_Blue * 65536)) / 256)
    HL_Red = Sender.Color - (HL_Blue * 65536) - (HL_Green * 256)
    EAE_ColorRGBToHLS(Sender.Color, VarPtr(EAE_lHue), VarPtr(EAE_lLum), VarPtr(EAE_lSat))
End Sub

'Public Declare Function ColorRGBToHLS Lib "shlwapi.dll" (ByVal clrRGB As Long, pwHue As Long, pwLuminance As Long, pwSaturation As Long) As Long
'Public Declare Function ColorHLSToRGB Lib "shlwapi.dll" (ByVal wHue As Long, ByVal wLuminance As Long, ByVal wSaturation As Long) As Long
