'All (and only) non-component subroutines/functions.

Sub Check_For_Modified
    CFM_Reply = mrNone
    If RichEdit.GetModified(TabNum) = True Then
      CFM_Reply = MessageDlg("File " & Code_Editor_TabControl.Tab(TabNum) & " has been Modified." & Chr$(10) & Chr$(10) & "Please Confirm!  Save Changes?", mtWarning, mbYes Or mbNo Or mbCancel, 0)
      If CFM_Reply = mrYes Then mFile_OnClick(mfSaveTabAs)
    End If
End Sub

Sub Lose_Focus
    SetFocus(RichEdit.Handle(TabNum))
End Sub

Function Shorten_Long_Filename(filename As String) As String
    Dim FileNameLength As Long
        FileNameLength = Len(filename)
    If FileNameLength < 65 Then
      Result = filename
    Else
      Result = Left$(filename, (64 - (Len(Right$(filename, Len(filename) - rInstr(filename, "\")) + 4)))) & "...." & Right$(filename, Len(filename) - rInstr(filename, "\"))
    End If
End Function

Function Check_For_Can_Load(need As Integer) As Long
    Dim ClosedTabCount As Long
        ClosedTabCount = (MaxTabCnt - TabCnt - 1)
    Dim OpenEmptyTabCount As Long
        OpenEmptyTabCount = 0
    Dim TotalEmptyTabCount As Long
        TotalEmptyTabCount = 0
    Dim i As Long
        i = 0
    For i = 0 To TabCnt
      If Code_Editor_TabControl.Tab(i) = "" Then Inc(OpenEmptyTabCount)
    Next i
    TotalEmptyTabCount = ClosedTabCount + OpenEmptyTabCount
    Result = IIf(need <= TotalEmptyTabCount, need, TotalEmptyTabCount)
End Function

Sub LoadFile(index As Long, filename As String)
    NameOfFile(index) = filename
    Code_Editor_TabControl.Tab(index) = Right$(filename, Len(filename) - rInstr(filename,"\"))
    RichEdit.LoadFromFile(index, filename)
    Update_Tab_Icon(index)
End Sub

Sub Tab_Adjusted_File_Load(filename As String)
    Dim ClosedTabCount As Long
        ClosedTabCount = (MaxTabCnt - TabCnt - 1)
    Dim OpenEmptyTabCount As Long
        OpenEmptyTabCount = 0
    Dim TotalEmptyTabCount As Long
        TotalEmptyTabCount = 0
    Dim i As Long
        i = 0
    OpenEmptyTabIndex.Clear
    For i = 0 To TabCnt
      If Code_Editor_TabControl.Tab(i) = "" And RichEdit.GetModified(i) = False Then Inc(OpenEmptyTabCount)
    Next i
    TotalEmptyTabCount = ClosedTabCount + OpenEmptyTabCount
    If TotalEmptyTabCount > 0 Then
      If (TabCnt = 0) And (OpenEmptyTabCount = 1) Then
        LoadFile(TabNum, filename)
      End If
      If (TabCnt >= 0) And (OpenEmptyTabCount = 0) Then
        mFile_OnClick(mfNewTab)
        LoadFile(TabNum, filename)
      End If
      If (TabCnt > 0) And (OpenEmptyTabCount > 0 ) Then
        For i = 0 To TabCnt
          If Code_Editor_TabControl.Tab(i) = "" Then OpenEmptyTabIndex.AddItems(Str$(i))
        Next i
        For i = (OpenEmptyTabIndex.ItemCount - 1) To 0 Step -1
          Code_Editor_TabControl.TabIndex = Val(OpenEmptyTabIndex.Item(i))
          Code_Editor_TabControl_OnChange
          mFile_OnClick(mfCloseTab)
        Next i
        mFile_OnClick(mfNewTab)
        LoadFile(TabNum, filename)
      End If
    End If
End Sub

Sub PF_PM_Code_Editor_Load(filename As String)
    Update_StatusBar_Icon(1)
    Dim MissingFile As String
        MissingFile = ""
    Dim i As Long
        i = 0
    Dim n As Long
        n = 0
    If FileExists(filename) Then
      n = Check_For_Can_Load(1)
      If n = 1 Then
        Tab_Adjusted_File_Load(filename)
        If Previous_File_TreeView.ItemCount = 0 Then
          Previous_File_TreeView.AddItems(filename)
        Else
          Previous_File_TreeView.InsertItem(0, filename)
        End If
        If Previous_File_TreeView.ItemCount > 1 Then
          For i = (Previous_File_TreeView.ItemCount - 1) To 1 Step -1
            If LCase$(Previous_File_TreeView.Item(i).Text) = LCase$(filename) Then Previous_File_TreeView.DelItems(i)
          Next i
        End If
        Previous_File_TreeView.ItemIndex = 0
      Else
        MessageDlg("Error: You need to close (or clear) 1 tab." & Chr$(10) & Chr$(10) & _
                   "Solution: See Troubleshooting section in the Help file" & Chr$(10) & _
                   "                for a way to avoid this error in the future.", mtError, mbOk, 0)
      End If
    Else
      MissingFile = Shorten_Long_Filename(filename)
      If MessageDlg("Error: " & UCase$(MissingFile) & Chr$(10) & Chr$(10) &  "No longer exists. Do you want it removed from the Previous Files list?", mtError, mbYes Or mbNo, 0) = mrYes Then Previous_File_TreeView.DelItems(Previous_File_TreeView.ItemIndex)
    End If
    MainForm_OnResize
    Update_StatusBar_Icon(0)
End Sub

Sub PP_PM_Code_Editor_Load(filename As String)
    Update_StatusBar_Icon(1)
    Dim MissingFile As String
        MissingFile = ""
    Dim MissingFileList As QStringList
        MissingFileList.Clear
    Dim i As Long
        i = 0
    Dim n As Long
        n = 0
    If FileExists(filename) Then
      ProjectList.Clear
      ProjectList.LoadFromFile(filename)
      MissingFileList.Clear
      For i = 0 To (ProjectList.ItemCount - 1)
        If FileExists(ProjectList.Item(i)) = 0 Then MissingFileList.AddItems(Shorten_Long_Filename(ProjectList.Item(i)))
      Next i
      If MissingFileList.ItemCount = 0 Then
        n = Check_For_Can_Load(ProjectList.ItemCount)
        If n = ProjectList.ItemCount Then
          For i = 0 To (ProjectList.ItemCount - 1)
            Tab_Adjusted_File_Load(ProjectList.Item(i))
          Next i
          If Previous_Project_TreeView.ItemCount = 0 Then
            Previous_Project_TreeView.AddItems(filename)
          Else
            Previous_Project_TreeView.InsertItem(0, filename)
          End If
          If Previous_Project_TreeView.ItemCount > 1 Then
            For i = (Previous_Project_TreeView.ItemCount - 1) To 1 Step -1
              If LCase$(Previous_Project_TreeView.Item(i).Text) = LCase$(filename) Then Previous_Project_TreeView.DelItems(i)
            Next i
            Previous_Project_TreeView.ItemIndex = 0
          End If
        Else
          MessageDlg("Error: You need to close (or clear) " & Str$(ProjectList.ItemCount - n) & " tab" & IIF(n < 2, ".", "s.") & Chr$(10) & Chr$(10) & _
                     "Solution: See Troubleshooting section in the Help file" & Chr$(10) & _
                     "                for a way to avoid this error in the future.", mtError, mbOk, 0)
        End If
      Else
        MessageDlg("Error: Project file " & UCase$(Right$(filename, Len(filename) - rInstr(filename,"\"))) & " contains " & Str$(MissingFileList.ItemCount) & " file" & IIF(MissingFileList.ItemCount < 2, "", "s") & " which no longer exists." & Chr$(10) & Chr$(10) & _
                   MissingFileList.Text & Chr$(10) & _
                   "Solution: Try loading it into the Project Editor.", mtError, mbOk, 0)
      End If
    Else
      MissingFile = Shorten_Long_Filename(filename)
      If MessageDlg("Error: " & UCase$(MissingFile) & Chr$(10) & Chr$(10) &  "No longer exists. Do you want it removed from the Previous Projects list?", mtError, mbYes Or mbNo, 0) = mrYes Then Previous_Project_TreeView.DelItems(Previous_Project_TreeView.ItemIndex)
    End If
    MainForm_OnResize
    Update_StatusBar_Icon(0)
End Sub

Sub PP_PM_Project_Editor_Load(filename As String)
    Update_StatusBar_Icon(1)
    Dim i As Long
        i = 0
    If FileExists(filename) Then
      If Previous_Project_TreeView.ItemCount = 0 Then
        Previous_Project_TreeView.AddItems(filename)
      Else
        Previous_Project_TreeView.InsertItem(0, filename)
      End If
      If Previous_Project_TreeView.ItemCount > 1 Then
        For i = (Previous_Project_TreeView.ItemCount - 1) To 1 Step -1
          If LCase$(Previous_Project_TreeView.Item(i).Text) = LCase$(filename) Then Previous_Project_TreeView.DelItems(i)
        Next i
      End If
      ProjectFilename = filename
      ProjectList.Clear
      ProjectList.LoadFromFile(filename)
      Project_Editor_TreeView.Clear
      Project_Editor_TreeView.AddItems("Project: " & Right$(filename, Len(filename) - rInstr(filename, "\")) - ".rqp")
      For i = 0 To (ProjectList.ItemCount - 1)
        If FileExists(ProjectList.Item(i)) = 0 Then
          Project_Editor_TreeView.AddChildItems(0, "Missing File: " & ProjectList.Item(i))
        Else
          Project_Editor_TreeView.AddChildItems(0, ProjectList.Item(i))
        End If
      Next i
      ProjectModified = False
    Else
      MessageDlg(Chr$(10) & "Error: File " & Shorten_Long_Filename(filename) & " no longer exists!", mtError, mbOk, 0)
    End If
    Update_StatusBar_Icon(0)
End Sub

Sub Open_External_ProjectFile
    OpenDialog.Caption  = " Open a Project File"
    OpenDialog.Filter   = " RQ Project Files                                  RQP|*.rqp"
    OpenDialog.Filename = ""
    If OpenDialog.Execute Then
      PP_PM_Project_Editor_Load(OpenDialog.Filename)
      ProjectName = Mid$(Project_Editor_TreeView.Item(0).Text, 10)
      Project_Editor_TreeView.FullExpand
    End If
    OpenDialog.InitialDir = ""
End Sub

Function Check_For_PE_Missing_Files() As Long
    Dim i As Long
        i = 0
    Dim n As Long
        n = 0
    For i = 1 To (Project_Editor_TreeView.ItemCount - 1)
      If Left$(Project_Editor_TreeView.Item(i).Text, 14) = "Missing File: " Then INC(n)
    Next i
    Result = n
End Function

Sub Update_Tab_Icon(index As Byte)
    SendMessage(hTabCtrl, TCM_GETITEMW, index, TCI)
    TstIco = TCI.iImage
    TstMod = RichEdit.GetModified(index)
    TstExt = lCase$(Right$(NameOfFile(index), Len(NameOfFile(index)) - rInstr(NameOfFile(index), ".")))

    If TstMod = False Then
      If TstExt = "" Then
        If TstIco <> 0 Then
          TCI.mask   = TCIF_IMAGE
          TCI.iImage = 0
          SendMessage(hTabCtrl, TCM_SETITEMW, index, TCI)
        End If
      ElseIf TstExt = "inc" Then
        If TstIco <> 2 Then
          TCI.mask   = TCIF_IMAGE
          TCI.iImage = 2
          SendMessage(hTabCtrl, TCM_SETITEMW, index, TCI)
        End If
      Else
        If TstIco <> 4 Then
          TCI.mask   = TCIF_IMAGE
          TCI.iImage = 4
          SendMessage(hTabCtrl, TCM_SETITEMW, index, TCI)
        End If
      End If
    Else
      If TstExt = "" Then
        If TstIco <> 1 Then
          TCI.mask   = TCIF_IMAGE
          TCI.iImage = 1
          SendMessage(hTabCtrl, TCM_SETITEMW, index, TCI)
        End If
      ElseIf TstExt = "inc" Then
        If TstIco <> 3 Then
          TCI.mask   = TCIF_IMAGE
          TCI.iImage = 3
          SendMessage(hTabCtrl, TCM_SETITEMW, index, TCI)
        End If
      Else
        If TstIco <> 5 Then
          TCI.mask   = TCIF_IMAGE
          TCI.iImage = 5
          SendMessage(hTabCtrl, TCM_SETITEMW, index, TCI)
        End If
      End If
    End If
End Sub

Sub Update_StatusBar_Icon(index As Long)
    If hIcon <> 0 Then DestroyIcon(hIcon)
    hIcon = ImageList_GetIcon(sbImageList.Handle, index, 0)
    SendMessage(StatusBar.Handle, SB_SETICON, 1, hIcon)
End Sub

Sub Close_All_Tabs
    Dim n As Long
        n = 0
    Update_StatusBar_Icon(1)
    MainForm.Repaint
    Code_Editor_TabControl.TabIndex = TabCnt
    Code_Editor_TabControl_OnChange
    For n = TabCnt To 0 Step -1
      Code_Editor_TabControl.TabIndex = n
      Code_Editor_TabControl_OnChange
      If RichEdit.GetModified(n) = True Then
        If MessageDlg("File " & Code_Editor_TabControl.Tab(n) & " has been Modified." & Chr$(10) & Chr$(10) & "Please Confirm!  Save Changes?", mtWarning, mbYes Or mbNo, 0) = mrYes Then
          mFile_OnClick(mfSaveTabAs)
        End If
      End If
    Next n
    Code_Editor_TabControl.TabIndex = 0
    Code_Editor_TabControl_OnChange
    For n = TabCnt To 0 Step -1
      Code_Editor_TabControl.Tab(n) = ""
      RichEdit.Clear(n)
      NameOfFile(n) = ""
      If n > 0 Then
        Code_Editor_TabControl.DelTabs(TabCnt)
        Dec(TabCnt)
      Else
        mFile_OnClick(mfClearTab)
      End If
    Next n
    Compiler_Results_Richedit.Clear
    MainForm_OnResize
    Update_StatusBar_Icon(0)
End Sub

Sub Compile_Run_OnClick(run_it As Long)
    Dim ShortAppName As String
        ShortAppName = Left$(Code_Editor_TabControl.Tab(TabNum), rInStr(Code_Editor_TabControl.Tab(TabNum), ".")) & "exe"
    Dim OriginName As String
        OriginName = ""
    Dim BackupName As String
        BackupName = ""
    Dim CompilerString As String
        CompilerString = ""
    Dim OutFileName As String
        OutFileName = ""
    Dim OutFilePath As String
        OutFilePath = ""
    Dim FileInError As String
        FileInError = ""
    Dim CRLF As String
        CRLF = Chr$(13) & Chr$(10)

    Dim Out_File_Size As Long
        Out_File_Size = 0
    Dim SourceErrorLine As Long
        SourceErrorLine = 0
    Dim CompilerErrorLine As Long
        CompilerErrorLine = 0
    Dim ErrorLineNumberBgn As Long
        ErrorLineNumberBgn = 0
    Dim ErrorLineNumberEnd As Long
        ErrorLineNumberEnd = 0
    Dim ErrorLineNumber As Long
        ErrorLineNumber = 0
    Dim hFile As Long
        hFile = 0
    Dim lRet As Long
        lRet = 0
    Dim i As Long
        i = 0

    Dim FileNames As QStringList
        FileNames.Clear
    Dim ModifiedFiles As QStringList
        ModifiedFiles.Clear

    Compiler_Results_Richedit.Clear

    Update_StatusBar_Icon(1)

    For i = 0 To TabCnt
      If RichEdit.GetModified(i) = True Then ModifiedFiles.AddItems(STR$(i))
    Next i

C1: CMC_Reply = mrNone

    If ((Check_For_Running(ShortAppName) = False And lCase$(ShortAppName) <> "editaide.exe")) Or ((Check_For_Running(ShortAppName) = True And lCase$(ShortAppName) = "editaide.exe")) Then
      If (ModifiedFiles.ItemCount = 0) Or ((ModifiedFiles.ItemCount = 1) And (RichEdit.GetModified(TabNum) = True)) Then
        OriginName = NameOfFile(TabNum)
        BackupName = ""
        hFile = _lOpen(OriginName, 0)
        If hFile > 0 Then
          lRet = GetFileTime(hFile, cFILETIME, aFILETIME, mFILETIME)
          lRet = FileTimeToLocalFileTime(mFILETIME, mFILETIME)
          lRet = FileTimeToSystemTime(mFILETIME, SYSTEMTIME)
          BackupName = Left$(OriginName, rInStr(OriginName, ".") - 1) & "-[" & STR$(SYSTEMTIME.wYear) & Format$(".%.2d", SYSTEMTIME.wMonth) & Format$(".%.2d", SYSTEMTIME.wDay) & Format$("]-[%.2d", IIF(SYSTEMTIME.wHour > 12, SYSTEMTIME.wHour - 12, SYSTEMTIME.wHour)) & Format$(".%.2d", SYSTEMTIME.wMinute) & Format$(".%.2d", SYSTEMTIME.wSecond) & IIF(SYSTEMTIME.wHour > 12, " PM", " AM") & "]." & Right$(OriginName, 3)
        End If
        lRet = _lClose(hFile)
        If Compile_BackUp_Checkbox.Checked = True And BackupName <> "" Then ReName(OriginName, BackupName)
        mcRun.Enabled = False
        pcRun.Enabled = False
        RichEdit.Save(TabNum)
        Compiler_Results_Richedit.Text = "One moment please..."
        MainForm.Repaint
        Update_Menus
        If Compile_ByteCode_CheckBox.Checked = True Then
          OutFileName = Left$(OriginName, rInStr(OriginName, ".")) & "bc"
        Else
          OutFileName = Left$(OriginName, rInStr(OriginName, ".")) & "exe"
        End If
        OutFilePath = Left$(OriginName, rInStr(OriginName, "\"))
        CompilerString = Left$(OutFilePath, 2) & CRLF & _
          "cd \" & CRLF & _
          "cd " & Right$(OutFilePath, Len(OutFilePath) - 2) & CRLF & _
          InstallPath & "rc -r "  & _
          IIF(Compile_GUI_RadioButton.Checked   = True, "-GUI ", "-CONS ") & _
          IIF(Compile_Verbose_Checkbox.Checked  = True, "-vON ", "-vOFF ") & _
          IIF(Compile_Optimize_Checkbox.Checked = True, "-opt ", "") & _
          IIF(Compile_ByteCode_CheckBox.Checked = True, "-b ", "") & _
          IIF(Compile_Unix_CheckBox.Checked     = True, "-o ", "") & _
          "-I" & Chr$(34) & DefIncFolder & Chr$(34) & Chr$(32) & _
          "-L" & Chr$(34) & DefLibFolder & Chr$(34) & Chr$(32) & _
          "-G" & Chr$(34) & DefAppIcon & Chr$(34) & Chr$(32) & _
          Chr$(34) & OriginName & Chr$(34) & Chr$(32) & _
          Chr$(34) & OutFileName & Chr$(34) & CRLF & _
          "cls" & CRLF & _
          "@exit" & CRLF
        CompileStream.Open(OutFilePath + "MakeFile.bat", fmCreate)
          CompileStream.WriteLine(CompilerString)
          CompileStream.Position = 0
        CompileStream.Close
        PID = Shell(OutFilePath + "MakeFile.bat", 0)
        WaitForSingleObject (PID, &H7FFF)
        If FileExists(OutFilePath + "Dump.$$$") Then
          CompileStream.Open(OutFilePath + "Dump.$$$", fmOpenRead)
            Compiler_Results_Richedit.Text = CompileStream.ReadStr(CompileStream.Size)
            CompileStream.Position = 0
          CompileStream.Close
          Kill(OutFilePath + "Dump.$$$")
        End If
        If FileExists(OutFilePath + "MakeFile.bat") Then Kill(OutFilePath + "MakeFile.bat")
        If FileExists(OutFileName) Then
          CompileStream.Open(OutFileName, fmOpenRead)
          Out_File_Size = CompileStream.Size
          CompileStream.Position = 0
          CompileStream.Close
          If Out_File_Size = 0 Then
            Kill(OutFileName)
            mcRun.Enabled = False
            pcRun.Enabled = False
          Else
            mcRun.Enabled = True
            pcRun.Enabled = True
          End If
        End If
        For i = 0 To Compiler_Results_Richedit.LineCount
          If Left$(Compiler_Results_Richedit.Line(i), 5) = "Line " Then
            SourceErrorLine = SendMessageAPI(Compiler_Results_Richedit.Handle, EM_LINEINDEX, i, 0)
            CompilerErrorLine = i
          End If
          If Left$(Compiler_Results_Richedit.Line(i), 14) = "File in error:" Then
            FileInError = Mid$(Compiler_Results_Richedit.Line(i), 16, Len(Compiler_Results_Richedit.Line(i)) - 16)
          End If
        Next i
        If (SourceErrorLine = 0) And (FileInError = "") Then
          Compiler_Results_Richedit.AddStrings("No compiling errors were found.", "Compiled successfully.")
          Compiler_Results_Richedit.SelStart = SendMessageAPI(Compiler_Results_Richedit.Handle, EM_LINEINDEX, Compiler_Results_Richedit.LineCount - 1, 0)
        End If
        For i = 0 To TabCnt
          FileNames.AddItems(NameOfFile(i))
        Next i
        If FileInError <> "" Then
          FileInError = IIF(Instr(FileInError, ":"), FileInError, OutFilePath & FileInError)
          If FileNames.Find(FileInError) > -1 Then
            ErrorLineNumberBgn = SourceErrorLine + 5
            ErrorLineNumberEnd = InStr(ErrorLineNumberBgn, Compiler_Results_Richedit.Text, ":")
            ErrorLineNumber = Val(Mid$(Compiler_Results_Richedit.Text, ErrorLineNumberBgn, ErrorLineNumberEnd - ErrorLineNumberBgn)) - 1
            If FileNames.Find(FileInError) <> TabNum Then
              Code_Editor_TabControl.TabIndex = FileNames.Find(FileInError)
              Code_Editor_TabControl_OnChange
            End If
            Compiler_Results_Richedit.SelStart = Len(Compiler_Results_Richedit.Text)
            Compiler_Results_Richedit.SelStart = SendMessageAPI(Compiler_Results_Richedit.Handle, EM_LINEINDEX, CompilerErrorLine, 0)
            Richedit.SetSelStart(TabNum, Len(Richedit.GetText(TabNum)))
            If ErrorLineNumber = 0 Then
              lRet = SendMessageAPI(RichEdit.Handle(TabNum), EM_LINEINDEX, ErrorLineNumber, 0)
              RichEdit.SetSelStart(TabNum, lRet)
            Else
              lRet = SendMessageAPI(RichEdit.Handle(TabNum), EM_LINEINDEX, ErrorLineNumber - 1, 0)
              RichEdit.SetSelStart(TabNum, lRet)
              lRet = SendMessageAPI(RichEdit.Handle(TabNum), EM_LINEINDEX, ErrorLineNumber, 0)
              RichEdit.SetSelStart(TabNum, lRet)
            End If
            Update_Menus
          End If
          If FileNames.Find(FileInError) = -1 Then
            Update_Menus
            If Check_For_Can_Load(1) = 1 Then
              ErrorLineNumberBgn = SourceErrorLine + 5
              ErrorLineNumberEnd = IIF(rInStr(ErrorLineNumberBgn, Compiler_Results_Richedit.Text, ",") > 0, InStr(ErrorLineNumberBgn, Compiler_Results_Richedit.Text, ","), InStr(ErrorLineNumberBgn, Compiler_Results_Richedit.Text, ":"))
              ErrorLineNumber = Val(Mid$(Compiler_Results_Richedit.Text, ErrorLineNumberBgn, ErrorLineNumberEnd - ErrorLineNumberBgn)) - 1
              Tab_Adjusted_File_Load(FileInError)
              Compiler_Results_Richedit.SelStart = Len(Compiler_Results_Richedit.Text)
              Compiler_Results_Richedit.SelStart = SendMessageAPI(Compiler_Results_Richedit.Handle, EM_LINEINDEX, CompilerErrorLine, 0)
              Richedit.SetSelStart(TabNum, Len(Richedit.GetText(TabNum)))
              If ErrorLineNumber = 0 Then
                lRet = SendMessageAPI(RichEdit.Handle(TabNum), EM_LINEINDEX, ErrorLineNumber, 0)
                RichEdit.SetSelStart(TabNum, lRet)
              Else
                lRet = SendMessageAPI(RichEdit.Handle(TabNum), EM_LINEINDEX, ErrorLineNumber - 1, 0)
                RichEdit.SetSelStart(TabNum, lRet)
                lRet = SendMessageAPI(RichEdit.Handle(TabNum), EM_LINEINDEX, ErrorLineNumber, 0)
                RichEdit.SetSelStart(TabNum, lRet)
              End If
              Update_Menus
            Else
              MessageDlg("Error: Unable to load " & Shorten_Long_Filename(FileInError) & " for editing." & Chr$(10) & _
                         "           The compiler indicated that it might be the source of a problem." & Chr$(10) & Chr$(10) & _
                         "Solution: You need to close (or clear) 1 tab and then load it manually." & Chr$(10) & _
                         "                After which... edit it only if you're sure the problem is not somewhere else.", mtError, mbOk, 0)
            End If
          End If
        Else
          Update_Menus
          If run_it = True Then Run_OnClick
        End If
      Else
        CMC_Reply = MessageDlg("Warning: " & STR$(ModifiedFiles.ItemCount) & " loaded file" & IIF(ModifiedFiles.ItemCount > 1, "s have", " has") & " not been saved yet." & Chr$(10) & Chr$(10) & _
                               "           Do you want to continue?", mtWarning, mbYes Or mbNo, 0)
      End If
    Else
      MessageDlg("Error: Unable to compile to... " & ShortAppName & "  (because it's currently in use)" & Chr$(10) & Chr$(10) & _
                 "Solution: Close the already running application and then try compiling again.", _
                 mtError, mbOk, 0)
    End If
    If CMC_Reply = mrYes Then ModifiedFiles.Clear
    If CMC_Reply = mrYes Then Goto C1
    Update_StatusBar_Icon(0)
End Sub

Sub Run_OnClick
    If Mid$(ApplicationName, rInstr(ApplicationName,".")+1) = "exe" Then
      If FileExists(ApplicationName) = 0 Then
        mcRun.Enabled = False
        pcRun.Enabled = False
        MessageDlg(Chr$(10) &  "Application no longer exists." & Chr$(10) & "It was either deleted or moved.", mtInformation, mbOk, 0)
      Else
        If Compile_ParameterRun_Checkbox.Checked = False Then
          ChDir(ApplicationFolder)
          Run(ApplicationName)
        Else
          If ParameterForm.ShowModal = mrOk Then
            ChDir(ApplicationFolder)
            Run(ApplicationName & " " & ParameterFormEdit.Text)
          End If
        End If
      End If
    ElseIf Mid$(ApplicationName, rInstr(ApplicationName,".")+1) = "bc" Then
      If Instr(LCase$(RichEdit.GetText(TabNum)), "$apptype gui") Then
        If Instr(ApplicationName, " ") Then
          MessageDlg("Error: Source Code has a SPACE in the name." & Chr$(10) & Chr$(10) & _
                     "Solution: Rename Source Code WITHOUT a space." & Chr$(10) & _
                     "                Then try again.", _
                     mtError, mbOk, 0)
        Else
          ChDir(ApplicationFolder)
          Run("GUI_ByteCode_Launcher " & DefLibFolder & " " & ApplicationName)
        End If
      ElseIf Instr(LCase$(RichEdit.GetText(TabNum)), "$apptype console") Then
        If Instr(ApplicationName, " ") Then
          MessageDlg("Error: Source Code has a SPACE in the name." & Chr$(10) & Chr$(10) & _
                     "Solution: Rename Source Code WITHOUT a space." & Chr$(10) & _
                     "                Then try again.", _
                     mtError, mbOk, 0)
        Else
          ChDir(ApplicationFolder)
          Run("CON_ByteCode_Launcher " & DefLibFolder & " " & ApplicationName)
        End If
      ElseIf Compile_GUI_RadioButton.Checked = True Then
        If Instr(ApplicationName, " ") Then
          MessageDlg("Error: Source Code has a SPACE in the name." & Chr$(10) & Chr$(10) & _
                     "Solution: Rename Source Code WITHOUT a space." & Chr$(10) & _
                     "                Then try again.", _
                     mtError, mbOk, 0)
        Else
          ChDir(ApplicationFolder)
          Run("GUI_ByteCode_Launcher " & DefLibFolder & " " & ApplicationName)
        End If
      ElseIf Compile_CONSOLE_RadioButton.Checked = True Then
        If Instr(ApplicationName, " ") Then
          MessageDlg("Error: Source Code has a SPACE in the name." & Chr$(10) & Chr$(10) & _
                     "Solution: Rename Source Code WITHOUT a space." & Chr$(10) & _
                     "                Then try again.", _
                     mtError, mbOk, 0)
        Else
          ChDir(ApplicationFolder)
          Run("CON_ByteCode_Launcher " & DefLibFolder & " " & ApplicationName)
        End If
      End If
    End If
    ChDir(InstallPath)
End Sub

Function Check_For_Running(exename As String) As Long
    Dim hSnapShot As Long
        hSnapShot = 0
    Dim lRet As Long
        lRet = 0
    Dim IsRunning As Long
        IsRunning = False
    hSnapShot = CreateToolhelp32Snapshot(TH32CS_SNAPALL, &H0)
    lRet = Process32First(hSnapShot, PROCESSENTRY32)
    While lRet
      If Left$(PROCESSENTRY32.szExeFile, IIf(InStr(1, PROCESSENTRY32.szExeFile, Chr$(0)) > 0, InStr(1, PROCESSENTRY32.szExeFile, Chr$(0)) - 1, 0)) = exename Then IsRunning = True
      lRet = Process32Next(hSnapShot, PROCESSENTRY32)
    Wend
    CloseHandle(hSnapShot)
    Result = IsRunning
End Function

Function ContextHelp_GetWord(index As Long) As String
    Dim TxtStr As String
        TxtStr = ""
    Dim TxtLen As Long
        TxtLen = 0
    Dim Position As Long
        Position = 0
    Dim PointA As Long
        PointA = 0
    Dim PointB As Long
        PointB = 0
    Dim i As Long
        i = 0
    TxtStr = RichEdit.GetLine(index, RichEdit.WhereY(index))
    TxtLen = Len(TxtStr)
    Position = RichEdit.WhereX(index) + 1
    If ParserList.Find(Mid$(TxtStr, Position, 1)) > -1 Then Position = Position - 1
    If Position = 0 Then Goto F1
    For i = Position To 1 Step -1
      If ParserList.Find(Mid$(TxtStr, i, 1)) <> -1 Then Exit For
    Next i
    PointA = i + 1
F1: For i = Position To TxtLen
      If ParserList.Find(Mid$(TxtStr, i, 1)) <> -1 Then Exit For
    Next i
    PointB = i
    Result = Mid$(TxtStr, PointA, PointB - PointA)
End Function

Function GetChildHandle(ByVal hParent As Long, ByVal sClass As String, ByVal bInstance As Long) As Long
    gCnt = 0
    gWnd = GetWindow(hParent, GW_CHILD)
    Do
      gStr = Space$(255)
      GetClassName(gWnd, VarPtr(gStr), 255)
      If LCase$(Left$(gStr, Instr(gStr, Chr$(0))-1)) = LCase$(sClass) Then Inc(gCnt)
      If gCnt = bInstance Then Exit Do
      gWnd = GetWindow(gWnd, GW_HWNDNEXT)
    Loop Until gWnd = 0
    Result = gWnd
End Function

Sub Test_OnClick
'    DefLng ss = RichEdit.GetTextLength(TabNum)
'    ShowMessage(STR$(ss))
'    Lose_Focus
End Sub
